// 7-21-2011
// Made changes to poured fill.
// Removed all D02*'s from the pour (except for the first one after the G36*)
// Added a D02* before the G37*
// Eliminate reiterating of the XY position before starting a G02/03* arc in outlines
// - make sure this doesn't break anything if the first point is an arc segment
// Only write G74* or G75 once (or if the mode changes)
// Add <CR><LF> to the end of each point
//
// Need to find closest point to an arc endpoint,
// not closest point to the pad center.
// Closest point to an pad center may cross the arc from an arc endpoint
// figure out why square pads are not showing up.  The outline looks good

// Version 2.8, Jan 31 2012
//      Fixed bug, solder mask enlargment only happened on top layer
unit Unit6;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,Registry,math;
type apt_rec = record
        shape,x,y,d_code      :Integer;
        end;
type drill_rec = record
        Tool,size,x,y         :Integer;
        end;
type line_rec = record
        x1,y1,x2,y2,on_off    :Integer;
        end;
type point_rec = record
        x1,y1,on_off          :Integer;
        end;
type pad_rec = record
        cut_in_pos            :TPoint;
        Plane,
        HoleSize,
        d_code,
        shape,
        width,height          :Integer;
        position              :TPoint;
        end;
type ps_line_rec = record
        x1,y1,x2,y2,layer     :Integer;
        slope,offset          :Extended;
        end;

type TFillsType = record
        position    :TPoint;
//        X           :Longint;
//        Y           :Longint;
        ArcSection  :Integer;
        Radius      :Integer;
	ArcCenter   :TPoint;
        end;

type
  TForm6 = class(TForm)
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    Button1: TButton;
    Memo1: TMemo;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    GroupBox2: TGroupBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    CheckBox21: TCheckBox;
    Button2: TButton;
    GroupBox3: TGroupBox;
    CheckBox20: TCheckBox;
    CheckBox22: TCheckBox;
    procedure Button1Click(Sender: TObject);
    Procedure Create1Gerber(Sender :TObject; id :Integer);
    procedure CreateNCDrill(Sender :TObject);
    procedure CreateBOM(Sender :TObject);
    procedure Write_Apts;
    procedure FormCreate(Sender: TObject);
    procedure ReadRegistry(Sender: TObject);
    procedure SaveRegistry(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PlaceDrillMark(Sender :TObject; var oFile :TextFile; x :Integer; y :Integer; h :Integer; d_code:Integer);
    procedure CreateGDDGerber(Sender :TObject; id :Integer);
    function  WriteGerberChar(Sender :TObject; var oFile :TextFile; x :Integer; y :Integer; d_code :Integer; data :Char; theight :Integer; direction :Integer):TPoint;
    procedure  WriteGerberString(Sender :TObject; var oFile :TextFile; x :Integer; y :Integer; d_code :Integer; data :String; theight :Integer; direction :Integer);
    procedure delete_fill_entry(Sender :TObject; Index :Integer);
    function  find_point(Sender :TObject; spoint :TFillsType; var other_point :TFillsType) :Integer;
    procedure WriteArc(Sender :TObject; var oFile :TextFile);
    function  PointInPolygon(Sender :TObject; APoint, BPoint :TPoint; var closest_index :Integer; var closest_dist :Extended; var ix,iy :Integer):Boolean;
    procedure add_fill_entry(Sender :TObject; const lx1,ly1,lx2,ly2, ArcSec, Radius :Integer; ArcCenter :TPoint);
    procedure PadsInPolygon(Sender :TObject);
    function  LinesCross(Sender :TObject; l1e1,l1e2,l2e1,l2e2 :TPoint; var crosspoint :TPoint):Boolean;
    procedure Button2Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form6: TForm6;
  PCB_File_Name :String;
  APT_File_Name :String;
  BASE_File_Name :String;
  SolderMaskEnlargement,
  PasteMaskEnlargement,
  PlaneEnlargement :Integer;
  ifile,
  ofile     :TEXT;
  PCB_Min_X,
  PCB_Max_X,
  PCB_Min_Y,
  PCB_Max_Y     :Integer;
  Form3Completed :Boolean;
  comment_d_code,
  ref_des_d_code,
  s_mask_d_code,
  p_mask_d_code,
  last_d_code,
  plane_d_code,
  pwr_d_code,
  gnd_d_code,
  d_code,
  next_dnum,
  x1,x2,y1,y2,
  layer,cheight,
  cwidth,linewidth,
  diameter,
  radius,
  holesize,
  padnum,
  plane,
  shape,
  rotation,
  fillx,filly,
  segments        :Integer;

  ofilename,
  ctext           :String;

  LastGerberX,
  LastGerberY,
  LastGerberDCmd,
  LastGerberDCode  :Integer;

  comp_hide_ref,
  comp_hide_comment,
  comp_locked,

  ref_des_x,
  ref_des_y,
  ref_des_height,
  ref_des_width,
  ref_des_direction,
  ref_des_layer,

  comment_x,
  comment_y,
  comment_height,
  comment_width,
  comment_direction,
  comment_layer :Integer;

  ref_des_str,
  pattern_str,
  Comment_str     :String;

  pads_array        :Array of pad_rec;
  apts              :Array[0..1000] of apt_rec;
  drill_array       :Array of drill_rec;

  fills_array       :Array of Array[0..1] of TFillsType;
  fills_sort_array  :Array of TFillsType;

  Cut_In_array      :Array of pad_rec;

  fills_sort_array_mid_x,
  fills_sort_array_mid_y,
  fills_sort_array_min_x,
  fills_sort_array_min_y,
  fills_sort_array_max_x,
  fills_sort_array_max_y :Integer;

  procedure Aptline(line:string; var dcode:integer;
                                 var shape :string;
                                 var xsize  :integer;
                                 var ysize  :integer);   Forward;
  procedure reset_data;
  procedure GetPad(LocS:String);
  procedure GetArc(LocS:String);
  procedure GetComponent(var iFile :Textfile);
  procedure GetString(LocS:String);
  procedure GetTrack(LocS:String);
  procedure GetVia(LocS:String);
  procedure GetFill(LocS:String);
  function getbin(LocS :string; var LocX:Integer):integer;
  function SqLineMagnitude(const x1, y1, x2, y2: extended): extended;   Forward;
  function DistantPoint(const p1, p2 :TPoint): TPoint;
  procedure PointsToSlopeOffset(l1e1,l1e2:TPoint; var Slope, Offset :Extended);
  function P2PDistance(const p1,p2 :TPoint): extended;
  function CheckLimits(const l1e1,l1e2,l2e1,l2e2,CrossPoint :TPoint): Boolean;
  function IsCutIn(Const APoint :TFillsType; var Index :Integer):Boolean;
  function PointToLine(const l1e1,l1e2,p1 :TPoint; var crosspoint :TPoint; isarc :Integer):Integer;
  function ArcDirection(const ArcStart, ArcEnd, ArcCenter :TPoint; var StartAngle, EndAngle :Integer):Integer;
  function ClosestPointToPolygon(const APoint :TPoint; var CrossPoint :TPoint; var Index :Integer):Integer;
  procedure ChooseArcSeq(ThisPoint :pad_rec; var StartPoint :TPoint; var ArcSeq :Array of Integer);
  procedure InsertFSAEntry(const InsertAddress:Integer; const NewRec :TFillsType);
  procedure GetArcEndpoint(const ArcCenter, ArcStart :TPoint; const Radius, Segment :Integer; var EndPoint :TPoint);
  procedure DeleteCutIn(const Index :Integer);
  procedure BuildArcSequence(var ArcPoints :Array of TFillsType; APad_Rec :pad_rec; var ix,iy :Integer);
  procedure BuildRectangleSequence(var RectPoints :Array of TFillsType; APad_Rec :pad_rec; var ix,iy :Integer);
  procedure ChooseRectangleSeq(ThisPoint :pad_rec; var StartPoint :TPoint; var RectSeq :Array of TPoint);
  function  FindClosestRound(ppt :pad_rec;ClosestIndex :Integer):TPoint;Forward;
  function  FindClosestSquare(ppt :pad_rec;ClosestIndex :Integer):TPoint;Forward;
  procedure WriteGerberElement(const x, y, dCmd, dCode :Integer);

const
   REGNAME6 = '\Software\Cadcentric-6';

 EPS    = 0.000001;         // smallest positive value: less than that to be considered zero
 EPSEPS = EPS * EPS;        // and its square

DrillSquare :Array[0..5]of Point_Rec = (
   (x1:-1;y1:1;on_off:2),
   (x1:1; y1:1;on_off:1),
   (x1:1; y1:-1;on_off:1),
   (x1:-1;y1:-1;on_off:1),
   (x1:-1;y1:1;on_off:1),
   (x1:0;y1:0;on_off:3));

DrillSymbols :Array[0..31]of Array[0..2]of Point_Rec = (
   ((x1:0;y1:0;on_off:3),(x1:0;y1:0;on_off:3),(x1:0;y1:0;on_off:3)),   //0
   ((x1:0;y1:1;on_off:2),(x1:0;y1:0;on_off:1),(x1:0;y1:0;on_off:3)),   //1
   ((x1:0;y1:0;on_off:2),(x1:1;y1:0;on_off:1),(x1:0;y1:0;on_off:3)),   //2
   ((x1:0;y1:0;on_off:2),(x1:0;y1:-1;on_off:1),(x1:0;y1:0;on_off:3)),  //3
   ((x1:0;y1:0;on_off:2),(x1:-1;y1:0;on_off:1),(x1:0;y1:0;on_off:3)),  //4
   ((x1:0;y1:1;on_off:2),(x1:0;y1:-1;on_off:1),(x1:0;y1:0;on_off:3)),  //5
   ((x1:-1;y1:0;on_off:2),(x1:1;y1:0;on_off:1),(x1:0;y1:0;on_off:3)),  //6
   ((x1:-1;y1:0;on_off:2),(x1:1;y1:0;on_off:1),(x1:0;y1:1;on_off:1)),  //7
   ((x1:1;y1:0;on_off:2),(x1:-1;y1:0;on_off:1),(x1:0;y1:1;on_off:1)),  //8
   ((x1:-1;y1:-1;on_off:2),(x1:1;y1:1;on_off:1),(x1:0;y1:0;on_off:3)), //9
   ((x1:-1;y1:1;on_off:2),(x1:1;y1:-1;on_off:1),(x1:0;y1:0;on_off:3)), //10
   ((x1:0;y1:0;on_off:2),(x1:1;y1:1;on_off:1),(x1:0;y1:0;on_off:3)),   //11
   ((x1:0;y1:0;on_off:2),(x1:1;y1:-1;on_off:1),(x1:0;y1:0;on_off:3)),  //12
   ((x1:0;y1:0;on_off:2),(x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:3)), //13
   ((x1:0;y1:0;on_off:2),(x1:-1;y1:1;on_off:1),(x1:0;y1:0;on_off:3)),  //14
   ((x1:1;y1:-1;on_off:1),(x1:1;y1:1;on_off:1),(x1:0;y1:0;on_off:1)),  //15
   ((x1:1;y1:-1;on_off:1),(x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1)),//16
   ((x1:0;y1:0;on_off:1),(x1:-1;y1:-1;on_off:1),(x1:1;y1:1;on_off:1)), //17
   ((x1:-1;y1:-1;on_off:3),(x1:0;y1:0;on_off:1),(x1:0;y1:1;on_off:1)), //18
   ((x1:0;y1:0;on_off:1),(x1:1;y1:1;on_off:1),(x1:1;y1:1;on_off:3)),   //19
   ((x1:1;y1:1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)),  //20
   ((x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)),//21
   ((x1:0;y1:0;on_off:1),(x1:-1;y1:-1;on_off:1),(x1:1;y1:-1;on_off:3)),//22

   ((x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)),//23

   ((x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)),//24

   ((x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)),//25

   ((x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)),//26

   ((x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)),//27

   ((x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)),//28

   ((x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)),//29

   ((x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)),//30

   ((x1:-1;y1:-1;on_off:1),(x1:0;y1:0;on_off:1),(x1:1;y1:-1;on_off:1)) //31
         );

CharPtrs :Array[0..95]of Integer = (
0,0,21,42,81,147,225,291,
303,327,351,390,411,441,453,465,
489,543,573,633,711,741,795,855,
885,987,1047,1068,1101,1119,1140,1158,
1209,1281,1323,1401,1449,1497,1551,1599,
1647,1686,1734,1764,1803,1827,1857,1887,
1923,1971,2043,2097,2145,2169,2205,2223,
2277,2322,2364,2400,2427,2451,2475,2511,
2523,2535,2601,2661,2697,2757,2811,2850,
2916,2958,2979,3018,3060,3078,3138,3180,
3234,3294,3354,3390,3438,3471,3513,3531,
3585,3606,3660,3684,3726,3744,3786,3810);



CharWidths :Array[0..95]of Byte = (
6,2,3,6,6,6,6,2,4,4,6,6,2,6,2,6,5,4,6,6,6,6,6,6,6,6,2,2,4,6,5,5,
6,6,6,6,6,6,6,6,6,4,6,6,6,6,6,6,6,6,6,6,6,6,8,8,6,6,6,4,6,4,6,6,
4,6,6,6,6,6,6,6,6,2,5,6,3,6,5,6,6,6,6,6,6,6,6,6,6,6,6,4,2,4,6,0);


CharData :Array[0..3839] of ShortInt=(
0,0,2,0,0,1,0,1,1,0,2,2,0,2,1,0,6,1,0,6,1,0,4,1,0,4,1,0,6,1,1,4,
2,1,4,1,1,6,1,1,6,1,4,2,1,4,2,1,0,2,1,4,4,2,4,4,1,0,4,1,1,0,2,1,
0,1,1,6,1,3,0,2,3,0,1,3,6,1,3,6,1,3,1,1,3,1,1,0,1,1,3,1,2,4,2,1,
4,2,2,3,3,1,3,3,2,1,3,1,1,3,2,0,4,1,0,4,2,1,5,1,4,5,2,1,5,1,4,5,
2,2,5,1,2,5,2,2,6,1,2,0,2,2,6,1,2,6,1,0,5,1,0,5,1,0,6,1,1,5,2,0,
5,1,1,5,2,1,6,1,1,6,2,0,6,1,4,5,2,4,5,1,4,6,1,0,1,2,4,5,1,0,0,2,
0,1,1,4,0,2,4,0,1,3,0,1,3,0,2,3,1,1,4,1,2,3,1,1,4,0,2,4,1,1,4,1,
1,2,0,1,2,0,1,4,2,1,2,0,2,1,0,1,1,0,2,0,1,1,0,1,2,0,2,1,0,2,2,2,
4,1,2,4,2,2,5,1,2,5,2,1,6,1,0,5,2,1,6,1,0,4,2,0,5,1,4,0,2,0,4,1,
0,4,1,0,4,1,0,4,1,0,6,1,0,6,1,0,4,1,0,4,1,2,6,1,0,2,2,0,4,1,2,0,
2,0,2,1,0,2,1,2,4,1,2,4,1,0,6,1,2,2,2,2,4,1,0,0,2,2,2,1,2,2,1,2,
1,1,2,1,1,2,5,1,4,3,2,4,3,1,0,3,1,0,1,2,0,1,1,4,5,1,4,1,2,4,1,1,
0,5,1,0,5,1,2,1,1,2,1,1,2,5,1,4,3,2,4,3,1,0,3,1,0,3,1,0,0,1,0,0,
1,0,1,1,0,0,2,0,1,1,-1,-1,2,0,0,1,-1,-1,2,0,0,1,0,0,1,0,3,1,0,3,1,4,
3,1,4,3,1,0,0,1,0,0,1,0,1,1,0,1,1,0,0,1,0,0,1,0,1,1,0,1,2,4,5,1,
4,5,2,4,6,1,4,6,1,1,0,1,1,0,1,0,1,1,0,1,2,0,5,1,0,5,2,1,6,1,2,6,
2,1,6,1,3,5,2,2,6,1,3,1,2,3,5,1,2,0,2,3,1,1,2,0,2,1,0,1,1,0,1,0,
5,1,0,5,1,1,6,1,1,0,2,1,6,1,1,0,2,0,0,1,2,0,2,0,0,1,0,0,1,0,5,1,
0,5,1,1,6,1,3,6,2,1,6,1,4,5,2,3,6,1,4,4,2,4,5,1,3,3,2,4,4,1,3,3,
2,1,3,1,0,2,2,1,3,1,0,0,2,0,2,1,4,0,2,0,0,1,0,0,1,0,5,1,0,5,1,1,
6,1,3,6,2,1,6,1,4,5,2,3,6,1,4,4,2,4,5,1,3,3,2,4,4,1,3,3,2,2,3,1,
3,3,2,2,3,1,4,2,2,3,3,1,4,1,2,4,2,1,3,0,2,4,1,1,3,0,2,1,0,1,1,0,
2,0,1,1,0,1,1,4,2,1,4,2,1,0,2,1,0,2,2,0,3,1,0,3,2,3,6,1,3,0,2,3,
6,1,3,6,1,1,0,1,1,0,1,0,1,1,3,0,2,1,0,1,3,0,2,4,1,1,4,1,2,4,3,1,
4,3,2,3,4,1,3,4,2,0,4,1,0,4,2,0,6,1,4,6,2,0,6,1,0,6,1,3,3,1,3,3,
1,0,3,1,4,2,2,3,3,1,4,1,2,4,2,1,3,0,2,4,1,1,3,0,2,1,0,1,1,0,2,0,
1,1,0,1,2,0,4,1,0,4,2,2,6,1,3,6,2,2,6,1,2,6,1,4,6,1,4,6,1,0,6,1,
4,5,2,4,6,1,0,1,2,4,5,1,0,0,2,0,1,1,0,1,1,1,0,1,1,0,1,0,1,1,0,1,
2,0,2,1,0,2,2,1,3,1,3,3,2,1,3,1,3,3,2,4,4,1,4,4,2,4,5,1,4,5,2,3,
6,1,3,6,2,1,6,1,0,5,2,1,6,1,0,4,2,0,5,1,1,3,2,0,4,1,3,3,2,1,3,1,
4,2,2,3,3,1,4,1,2,4,2,1,3,0,2,4,1,1,3,0,2,1,0,1,1,0,1,2,0,1,2,0,
1,1,0,1,2,0,2,4,2,1,4,2,2,4,5,1,4,5,2,3,6,1,3,6,2,1,6,1,0,5,2,1,
6,1,0,4,2,0,5,1,1,3,2,0,4,1,4,3,2,1,3,1,1,3,1,0,3,1,0,3,1,0,4,1,
0,1,2,0,1,1,0,2,1,0,2,1,0,3,1,0,3,1,0,4,1,0,0,2,0,0,1,0,2,1,-1,-1,
2,0,0,1,-1,-1,2,0,0,1,0,0,1,-1,3,1,-1,3,1,2,6,1,2,0,2,-1,3,1,-1,3,1,4,
4,1,4,4,1,0,4,1,4,2,2,4,2,1,0,2,1,0,2,1,3,3,1,3,3,1,0,6,1,0,0,2,
3,3,1,3,3,1,0,5,1,0,5,1,1,6,1,2,6,2,1,6,1,3,5,2,2,6,1,3,4,2,3,5,
1,2,3,2,3,4,1,2,2,2,2,3,1,2,0,2,2,0,1,2,1,1,2,1,1,2,1,1,2,1,1,2,
2,1,2,2,2,1,3,1,0,2,2,1,3,1,0,1,2,0,2,1,1,0,2,0,1,1,3,0,2,1,0,1,
3,0,2,4,1,1,4,1,2,4,5,1,4,5,2,3,6,1,3,6,2,1,6,1,0,5,2,1,6,1,1,6,
1,0,0,1,0,0,1,0,2,1,0,2,2,2,6,1,4,2,2,2,6,1,4,2,2,0,2,1,4,2,2,0,
2,1,4,0,2,4,2,1,4,2,1,3,0,1,3,0,1,0,0,1,3,0,2,4,1,1,4,1,2,4,2,1,
4,2,2,3,3,1,3,3,2,1,3,1,3,3,2,1,3,1,3,3,2,4,4,1,4,4,2,4,5,1,4,5,
2,3,6,1,3,6,2,0,6,1,1,6,2,0,6,1,1,0,2,1,6,1,1,6,1,3,0,1,3,0,1,4,
1,1,3,0,2,1,0,1,1,0,2,0,1,1,0,1,2,0,5,1,0,5,2,1,6,1,3,6,2,1,6,1,
4,5,2,3,6,1,3,6,1,3,0,1,3,0,1,0,0,1,3,0,2,4,1,1,4,1,2,4,5,1,4,5,
2,3,6,1,3,6,2,0,6,1,1,6,2,0,6,1,1,0,2,1,6,1,1,6,1,0,0,1,0,0,1,0,
6,1,4,6,2,0,6,1,4,6,2,0,6,1,0,3,2,0,6,1,2,3,2,0,3,1,2,3,2,0,3,1,
0,0,2,0,3,1,4,0,2,0,0,1,0,0,1,0,0,1,0,0,1,0,6,1,4,6,2,0,6,1,4,6,
2,0,6,1,0,3,2,0,6,1,2,3,2,0,3,1,2,3,2,0,3,1,0,0,2,0,3,1,0,3,1,4,
3,1,4,3,1,3,3,1,4,0,2,4,3,1,4,0,2,1,0,1,1,0,2,0,1,1,0,1,2,0,5,1,
0,5,2,1,6,1,4,6,2,1,6,1,1,6,1,0,0,1,0,0,1,0,6,1,4,3,2,4,3,1,4,6,
1,4,3,2,0,3,1,4,3,2,0,3,1,4,0,2,4,3,1,4,3,1,1,0,1,1,0,1,0,0,1,1,
0,2,1,6,1,1,6,2,0,6,1,2,6,2,0,6,1,2,6,2,1,6,1,1,0,2,1,6,1,2,0,2,
1,0,1,1,0,1,1,0,1,1,0,1,0,1,1,3,0,2,1,0,1,3,0,2,4,1,1,4,1,2,4,6,
1,4,6,1,0,0,1,0,0,1,0,6,1,1,3,2,1,3,1,4,6,1,1,3,2,0,3,1,1,3,2,0,
3,1,4,0,2,1,3,1,1,3,1,0,0,1,0,0,1,0,6,1,0,0,2,0,6,1,4,0,2,0,0,1,
0,0,1,0,0,1,0,0,1,0,6,1,2,2,2,0,6,1,2,2,2,4,6,1,4,0,2,4,6,1,4,6,
1,0,0,1,0,0,1,0,6,1,4,2,2,0,6,1,4,2,2,4,6,1,4,0,2,4,6,1,4,6,1,0,
0,1,0,0,1,0,6,1,4,6,2,0,6,1,4,0,2,4,6,1,4,0,2,0,0,1,4,0,2,0,0,1,
0,0,1,0,0,1,0,0,1,0,6,1,3,6,2,0,6,1,4,5,2,3,6,1,4,4,2,4,5,1,3,3,
2,4,4,1,3,3,2,0,3,1,0,0,2,0,3,1,0,3,1,3,1,1,3,1,1,2,2,1,2,0,2,3,
1,1,2,0,2,1,0,1,1,0,2,0,1,1,0,1,2,0,5,1,0,5,2,1,6,1,3,6,2,1,6,1,
4,5,2,3,6,1,4,2,2,4,5,1,3,1,2,4,2,1,4,0,2,3,1,1,3,1,1,0,0,1,0,0,
1,0,6,1,3,6,2,0,6,1,4,5,2,3,6,1,4,4,2,4,5,1,3,3,2,4,4,1,3,3,2,0,
3,1,1,3,2,0,3,1,4,0,2,1,3,1,1,3,1,1,0,1,1,0,1,0,1,1,3,0,2,1,0,1,
3,0,2,4,1,1,4,1,2,0,5,1,0,5,2,1,6,1,3,6,2,1,6,1,4,5,2,3,6,1,3,6,
1,4,6,1,4,6,1,0,6,1,4,6,2,2,6,1,2,0,2,2,6,1,2,6,1,0,1,1,0,1,1,0,
6,1,1,0,2,0,1,1,3,0,2,1,0,1,3,0,2,4,1,1,4,1,2,4,6,1,4,6,1,3,0,1,
3,0,1,0,6,1,3,0,2,6,6,1,6,6,1,0,1,1,0,1,1,0,6,1,1,0,2,0,1,1,1,0,
2,3,2,1,3,2,2,3,3,1,3,2,2,3,3,1,5,0,2,3,2,1,5,0,2,6,1,1,6,1,2,6,
6,1,6,6,1,0,0,1,0,0,1,0,1,1,0,1,2,4,5,1,4,5,2,4,6,1,0,5,2,0,5,1,
0,6,1,4,1,2,0,5,1,4,0,2,4,1,1,4,1,1,0,5,1,0,5,1,0,6,1,2,3,2,0,5,
1,2,0,2,2,3,1,2,0,2,2,3,1,2,3,2,4,5,1,4,5,2,4,6,1,4,6,1,4,6,1,4,
6,1,0,6,1,4,5,2,4,6,1,0,1,2,4,5,1,0,0,2,0,1,1,4,0,2,0,0,1,0,0,1,
0,0,1,0,0,1,0,6,1,2,6,2,0,6,1,2,0,2,2,0,1,0,0,1,0,0,1,0,5,1,0,5,
1,0,6,1,4,1,2,0,5,1,4,0,2,4,1,1,4,1,1,2,6,1,2,6,1,0,6,1,2,0,2,2,
6,1,2,0,2,0,0,1,0,0,1,2,0,1,2,0,1,2,6,1,0,4,2,2,6,1,0,4,2,2,6,1,
4,4,2,2,6,1,4,4,2,2,6,1,2,6,1,4,-1,1,4,-1,1,0,-1,1,0,-1,1,2,4,1,2,4,
1,0,6,1,0,6,1,2,0,1,2,0,1,1,0,1,1,0,2,0,1,1,0,1,2,0,3,1,0,3,2,1,
4,1,2,4,2,1,4,1,3,3,2,2,4,1,3,1,2,3,3,1,2,0,2,3,1,1,2,0,2,3,1,1,
4,0,2,3,1,1,3,1,1,0,0,1,0,0,1,0,6,1,0,2,2,0,6,1,0,2,2,2,4,1,3,4,
2,2,4,1,4,3,2,3,4,1,4,1,2,4,3,1,3,0,2,4,1,1,3,0,2,2,0,1,2,0,2,0,
2,1,0,2,1,4,4,1,4,4,1,1,4,1,0,3,2,1,4,1,0,1,2,0,3,1,1,0,2,0,1,1,
4,0,2,1,0,1,1,0,1,2,0,1,2,0,1,4,2,1,2,0,2,1,0,1,1,0,2,0,1,1,0,1,
2,0,3,1,0,3,2,1,4,1,2,4,2,1,4,1,4,2,2,2,4,1,4,2,2,4,6,1,4,0,2,4,
6,1,4,6,1,3,2,1,3,2,1,0,2,1,3,2,2,4,3,1,4,3,2,3,4,1,3,4,2,1,4,1,
0,3,2,1,4,1,0,1,2,0,3,1,1,0,2,0,1,1,3,0,2,1,0,1,1,0,1,3,3,1,3,3,
1,0,3,1,4,5,2,4,5,1,3,6,1,3,6,2,2,6,1,1,5,2,2,6,1,1,0,2,1,5,1,1,
5,1,1,-2,1,1,-2,1,0,-1,1,3,-2,2,1,-2,1,3,-2,2,4,-1,1,4,-1,2,4,3,1,4,3,2,
3,4,1,3,4,2,1,4,1,0,3,2,1,4,1,0,1,2,0,3,1,1,0,2,0,1,1,4,0,2,1,0,
1,1,0,1,0,0,1,0,0,1,0,6,1,0,2,2,0,6,1,0,2,2,2,4,1,3,4,2,2,4,1,4,
3,2,3,4,1,4,0,2,4,3,1,4,3,1,0,0,1,0,0,1,0,3,1,0,4,2,0,4,1,0,5,1,
0,5,1,1,-2,1,1,-2,1,0,-1,1,2,-2,2,1,-2,1,2,-2,2,3,-1,1,3,-1,2,3,3,1,3,4,
2,3,4,1,3,5,1,3,5,1,0,0,1,0,0,1,0,6,1,0,2,2,0,6,1,2,2,2,0,2,1,2,
2,2,4,4,1,2,2,2,4,4,1,4,0,2,2,2,1,2,2,1,0,1,1,0,1,1,0,6,1,1,0,2,
0,1,1,0,1,1,0,0,1,0,0,1,0,4,1,0,3,2,0,4,1,0,3,2,1,4,1,2,3,2,1,4,
1,2,2,2,2,3,1,2,2,2,2,3,1,2,3,2,3,4,1,4,3,2,3,4,1,4,0,2,4,3,1,4,
3,1,0,0,1,0,0,1,0,4,1,0,3,2,0,4,1,0,3,2,1,4,1,2,4,2,1,4,1,3,3,2,
2,4,1,3,0,2,3,3,1,3,3,1,3,0,1,3,0,1,1,0,1,1,0,2,0,1,1,0,1,2,0,3,
1,0,3,2,1,4,1,3,4,2,1,4,1,4,3,2,3,4,1,4,1,2,4,3,1,3,0,2,4,1,1,4,
1,1,0,-2,1,0,-2,1,0,0,1,0,-2,2,0,4,1,0,3,2,0,4,1,0,3,2,1,4,1,3,4,2,
1,4,1,4,3,2,3,4,1,4,1,2,4,3,1,3,0,2,4,1,1,3,0,2,0,0,1,0,0,1,4,-2,
1,4,-2,1,4,0,1,4,-2,2,4,4,1,4,3,2,4,4,1,4,3,2,3,4,1,3,4,2,1,4,1,0,
3,2,1,4,1,0,1,2,0,3,1,1,0,2,0,1,1,4,0,2,1,0,1,1,0,1,0,0,1,0,0,1,
0,4,1,0,2,2,0,4,1,0,2,2,2,4,1,3,4,2,2,4,1,4,3,2,3,4,1,3,4,1,3,0,
1,3,0,1,0,0,1,3,0,2,4,1,1,4,1,2,3,2,1,3,2,2,1,2,1,1,2,2,0,3,1,0,
3,2,1,4,1,4,4,2,1,4,1,1,4,1,4,4,1,4,4,1,0,4,1,2,1,2,2,1,1,2,6,1,
3,0,2,2,1,1,3,0,2,4,1,1,4,1,1,0,1,1,0,1,1,0,4,1,1,0,2,0,1,1,2,0,
2,1,0,1,2,0,2,4,2,1,4,2,2,4,4,1,4,0,2,4,4,1,4,4,1,2,0,1,2,0,1,0,
4,1,2,0,2,4,4,1,4,4,1,0,1,1,0,1,1,0,4,1,1,0,2,0,1,1,1,0,2,2,1,1,
2,1,2,2,2,1,2,1,2,2,2,1,3,0,2,2,1,1,3,0,2,4,1,1,4,1,2,4,4,1,4,4,
1,0,0,1,0,0,1,4,4,1,4,0,2,4,0,1,0,4,1,0,4,1,0,1,1,0,1,1,0,4,1,1,
0,2,0,1,1,2,0,2,1,0,1,2,0,2,4,2,1,4,2,2,4,4,1,4,-1,2,4,4,1,3,-2,2,
4,-1,1,3,-2,2,1,-2,1,1,-2,1,4,4,1,4,4,1,0,4,1,0,0,2,4,4,1,4,0,2,0,0,
1,0,0,1,1,5,1,1,5,1,2,6,1,1,4,2,1,5,1,0,3,2,1,4,1,1,2,2,0,3,1,1,
1,2,1,2,1,2,0,2,1,1,1,1,1,1,0,0,1,0,0,1,0,6,1,0,0,2,0,6,1,0,6,1,
0,0,1,0,0,1,1,1,1,1,1,2,1,2,1,1,2,2,2,3,1,2,3,2,1,4,1,1,4,2,1,5,
1,1,5,2,0,6,1,0,6,1,0,1,1,0,1,1,1,2,1,3,2,2,1,2,1,3,2,2,4,3,1,4,
3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
implementation

uses Unit1,unit3;


{$R *.DFM}
        const
        FileNames  :Array[1..16] of string =
              (
                  '.GTL',
                  '.GM1',
                  '.GM2',
                  '.GM3',
                  '.GM4',
                  '.GBL',
                  '.GTO',
                  '.GBO',
                  '.GDD',
                  '.GDG',
                  '.GTS',
                  '.GBS',
                  '.GGD',
                  '.GPW',
                  '.GTP',
                  '.GBP'
              ) ;
MULTI_LAYER = 13;
BOARD_LAYER = 11;
KEEPOUT_LAYER = 12;
TOP_LAYER = 1;
BOTTOM_LAYER = 6;

procedure TForm6.Button1Click(Sender: TObject);
begin
   PCB_Min_X := 1000000;
   PCB_Max_X := -1;
   PCB_Min_Y := 1000000;
   PCB_Max_Y := -1;
   Unit3.Form6Called := True;
   Form3Completed := False;
   Form3.Showmodal;
   Unit3.Form6Called := False;
   Application.ProcessMessages;
   if(Form3Completed = False) then exit;
   SolderMaskEnlargement := Form3.SpinEdit1.value;
   PasteMaskEnlargement := Form3.SpinEdit3.value;
   PlaneEnlargement := Form3.SpinEdit4.value;
   SetLength(fills_array,0);
   Memo1.lines.add(PCB_File_Name);
   Memo1.lines.add(APT_File_Name);
   Memo1.lines.add(BASE_File_Name);

   memo1.lines.add('Dimentions are: '+IntToStr(PCB_Min_X)+' '+ IntToStr(PCB_Min_Y)+', '+IntToStr(PCB_Max_X)+', '+IntToStr(PCB_Max_Y));
   if(Checkbox1.Checked) then Create1Gerber(self,1);
   if(Checkbox2.Checked) then Create1Gerber(self,2);
   if(Checkbox3.Checked) then Create1Gerber(self,3);
   if(Checkbox4.Checked) then Create1Gerber(self,4);
   if(Checkbox5.Checked) then Create1Gerber(self,5);
   if(Checkbox6.Checked) then Create1Gerber(self,6);
   if(Checkbox7.Checked) then Create1Gerber(self,7);
   if(Checkbox8.Checked) then Create1Gerber(self,8);
   if(Checkbox9.Checked) then CreateGDDGerber(self,9);
   if(Checkbox10.Checked) then Create1Gerber(self,10);
   if(Checkbox11.Checked) then Create1Gerber(self,11);    // Top solder mask
   if(Checkbox12.Checked) then Create1Gerber(self,12);    // Bottom solder mask
   if(Checkbox13.Checked) then Create1Gerber(self,13);    // ground plane
   if(Checkbox14.Checked) then Create1Gerber(self,14);    // power plane
   if(Checkbox18.Checked) then Create1Gerber(self,15);    // top paste
   if(Checkbox19.Checked) then Create1Gerber(self,16);    // bottom paste
   if(Checkbox17.Checked) then CreateNCDRill(self);
   if(Checkbox21.Checked) then CreateBOM(self);
   Memo1.lines.add('Done');

end;
//----------------------------------------------------------------------------
procedure TForm6.Create1Gerber(Sender :TObject; id :Integer);
var

new_data  :Boolean;
mode      :Char;
sa,ea,dir,
ArcXRadius,
ArcState,
fsa_ptr,
i,j,
x,y,z     :Integer;
lastpoint,
fill_end,
temp_point,
next_point:TFillsType;
tpnt2,
tpnt	:TPoint;
locs2,
locs    :String;
ArcSeq  :Array[0..3] of Integer;
lastx,
lasty,
G74Mode,
G02Mode :Integer;
begin
   LastGerberX:=-1;
   LastGerberY:=-1;
   LastGerberDCmd:=-1;
   LastGerberDCode:=-1;
   G74Mode :=0;
   G02Mode :=0;
   SetLength(Pads_array,0);
   last_d_code := -2;
   Memo1.lines.add(FileNames[id]);
   Assignfile(ofile,BASE_File_Name+FileNames[id]);
   ReWrite(ofile);
   Write_Apts;
   Assignfile(ifile,PCB_File_Name);
   RESET(ifile);
   ArcState:=0;



         while(not EOF(ifile)) do
         begin
            readln(ifile,inbuf);
            reset_data;
            new_data:=True;
            if ((inbuf='CP')OR(inbuf='FP')) then
               begin
                  mode:='P';
                  readln(ifile,inbuf);
                  GetPad(inbuf+' ');
               end
            else if ((inbuf='CA')OR(inbuf='FA')) then
               begin
                  mode:='A';
                  readln(ifile,inbuf);
                  GetArc(inbuf+' ');
               end
            else if ((inbuf='CT')OR(inbuf='FT')) then
               begin
                  mode:='T';
                  readln(ifile,inbuf);
                  GetTrack(inbuf+' ');
               end
            else if ((inbuf='CF')OR(inbuf='FF')) then
               begin
                  mode:='F';
                  readln(ifile,inbuf);
                  GetFill(inbuf+' ');
               end
// do strings
            else if ((inbuf='CS')OR(inbuf='FS')) then
               begin
                  mode:='S';
                  readln(ifile,inbuf);
                  GetString(inbuf+' ');
               end
// do component strings
            else if (inbuf='COMP') then
               begin
                  mode:='i';
                  New_Data:=False;
                  GetComponent(iFile);
                  if(
                     (comp_hide_comment = 1)AND
                     (
                       (comment_layer = id) OR
                       ((comment_layer = BOARD_LAYER) AND (Checkbox15.Checked))
                      )
                     ) then
                     WriteGerberString(Self, oFile, comment_x, comment_y, comment_d_code,Comment_str,comment_height,comment_direction);
                 if(
                     (comp_hide_ref = 1)AND
                     (
                       (ref_des_layer = id) OR
                       ((ref_des_layer = BOARD_LAYER) AND (Checkbox15.Checked))
                      )
                     ) then
                     WriteGerberString(Self, oFile, ref_des_x, ref_des_y, ref_des_d_code,ref_des_str,ref_des_height,ref_des_direction);

               end
            else if ((inbuf='CV')OR(inbuf='FV')) then
               begin
                  mode:='V';
                  readln(ifile,inbuf);
                  GetVia(inbuf+' ');
               end
            else
               begin
                  mode:='i';
                  New_Data:=False;
               end; {if else if}
//-----------------------------------------------------------------------------
            if (New_Data=True) AND
               (
                (layer = id) OR
                ((layer = TOP_LAYER) AND (id = 11)) OR    // allow top layer on top solder mask
                ((layer = TOP_LAYER) AND (id = 15)) OR    // allow top layer on top paste mask
                ((layer = BOTTOM_LAYER) AND (id = 12)) OR // allow bottom layer on bottom solder mask
                ((layer = BOTTOM_LAYER) AND (id = 16)) OR // allow bottom layer on bottom paste mask
                ((layer = MULTI_LAYER) AND (id <= 6)) OR  // allow multi layer on  top, bottom, and mid 1-4
                ((layer = MULTI_LAYER) AND (id = 10)) OR  // allow multi layer on drill guide
                ((layer = MULTI_LAYER) AND (id = 11)) OR  // allow multi layer on top soldermask
                ((layer = MULTI_LAYER) AND (id = 12)) OR  // allow multi layer on bottom solder mask
                ((layer = MULTI_LAYER) AND (id = 13)) OR  // allow multi layer on ground plane
                ((layer = MULTI_LAYER) AND (id = 14)) OR  // allow multi layer on power plane
                ((layer = BOARD_LAYER) AND (Checkbox15.Checked = True)) OR
                ((layer = KEEPOUT_LAYER) AND (Checkbox16.Checked = True))
                )then
            begin
if (Mode='V') then
              begin
                 if(id = 10) then d_code := 11;
                 if((id = 11) OR (id = 12)) then d_code := s_mask_d_code;
                 if((id = 13) OR (id = 14)) then d_code := plane_d_code;
                 if((id = 15) OR (id = 16)) then d_code := p_mask_d_code;

                 WriteGerberElement(x1, y1, 3, d_Code);
{
                 if(last_d_code <> d_code) then
                    begin
                       last_d_code := d_code;
                       Write(ofile,'D'+IntToStr(d_code)+'*');
                    end;
                  writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D03*');
}
// add to pads array
                  SetLength(Pads_array,High(Pads_Array)+2);
                  Pads_array[High(Pads_Array)].position.x := x1;
                  Pads_array[High(Pads_Array)].position.y := y1;
                  Pads_array[High(Pads_Array)].d_code := d_code;
                  Pads_array[High(Pads_Array)].shape := 1;
                  Pads_array[High(Pads_Array)].width := diameter;
                  Pads_array[High(Pads_Array)].height := diameter;
                  Pads_array[High(Pads_Array)].HoleSize := HoleSize;
                  Pads_array[High(Pads_Array)].Plane := 0;
              end
else if (Mode='P') then
              begin
                 if(id = 10) then d_code := 11;
                 if((id = 11) OR (id = 12)) then d_code := s_mask_d_code;
                 if((id = 13) OR (id = 14)) then d_code := plane_d_code;
                 if((id = 15) OR (id = 16)) then d_code := p_mask_d_code;
// for ground and power planes
// if gnd_d_code  = -1 then this is a clearence (no connection)
// if gnd_d_code  = 0 then this is nothing (direct connection)
// if gnd_d_code  > 0 then this is a themral

                 if(id = 13) then // gound plane
                    begin
                       if(gnd_d_code = 0) then continue;              // direct connection
                       if(gnd_d_code < 0) then d_code := plane_d_code // clearance
                       else d_code := gnd_d_code;
                    end;

                 if(id = 14) then // power plane
                    begin
                       if(pwr_d_code = 0) then continue;              // direct connection
                       if(pwr_d_code < 0) then d_code := plane_d_code // clearance
                       else d_code := pwr_d_code;
                    end;

                 WriteGerberElement(x1, y1, 3, d_Code);
{
                 if(last_d_code <> d_code) then
                    begin
                       last_d_code := d_code;
                       Write(ofile,'D'+IntToStr(d_code)+'*');
                    end;
                  writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D03*');
}
// add to pads array
                  SetLength(Pads_array,High(Pads_Array)+2);
                  Pads_array[High(Pads_Array)].position.x := x1;
                  Pads_array[High(Pads_Array)].position.y := y1;
                  Pads_array[High(Pads_Array)].d_code := d_code;
                  Pads_array[High(Pads_Array)].shape := shape;
                  Pads_array[High(Pads_Array)].width := cwidth;
                  Pads_array[High(Pads_Array)].height := cheight;
                  Pads_array[High(Pads_Array)].HoleSize := HoleSize;
                  Pads_array[High(Pads_Array)].Plane := plane;
              end
//else if(id = 10) then continue     // Drill guide
else if(id = 11) then continue     // Top solder mask
else if(id = 12) then continue     // Bottom solder mask
else if(id = 15) then continue     // Top paste mask
else if(id = 16) then continue     // Bottom paste mask


else if (Mode='S') then
              begin
                 WriteGerberString(Self, oFile, x1, y1, d_code,ctext,cheight,rotation);
              end

else if (Mode='F') then
              begin
              write(ofile,'G36*');
              WriteGerberElement(x1, y1, 2, 12);
              WriteGerberElement(x2, y1, 1, 12);
              WriteGerberElement(x2, y2, 1, 12);
              WriteGerberElement(x1, y2, 1, 12);
              WriteGerberElement(x1, y2, 1, 12);
              WriteGerberElement(x1, y2, 2, 12);
{
              write(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*');
              write(ofile,'D01*X'+IntToStr(x2)+'Y'+IntToStr(y1)+'*');
              write(ofile,'D01*X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*');
              write(ofile,'D01*X'+IntToStr(x1)+'Y'+IntToStr(y2)+'*');
              write(ofile,'D01*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*');
}
              writeln(ofile,'G37*');
              end
else if (Mode='T') then
              begin
                if((Checkbox20.Checked) AND (d_code = 12) AND (layer = id)) then
                   begin
                      tpnt.x := 0;
					  tpnt.y := 0;
                      add_fill_entry(Self, x1,y1,x2,y2,0,0,tpnt);
                   end
                else
                   begin

                       if((LastGerberX <> x1) OR (LastGerberY<>y1)) then WriteGerberElement(x1, y1, 2, d_Code);
                       WriteGerberElement(x2, y2, 1, d_Code);

{
                       if(last_d_code <> d_code) then
                          begin
                             last_d_code := d_code;
                             Write(ofile,'D'+IntToStr(d_code)+'*');
                          end;
                      writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');
}
                   end;
              end
else if (Mode='A') then
              begin
//***********************************
// Put arc endpoints in fills_array *
//***********************************
                if((Checkbox20.Checked) AND (linewidth = 1) AND (layer = id)) then
                   begin
                      tpnt.x := x1;
                      tpnt.y := y1;
                      if((segments AND 1)=1) then add_fill_entry(Self, x1,y1+radius,x1+radius,y1,1,radius,tpnt);
                      if((segments AND 2)=2) then add_fill_entry(Self, x1-radius,y1,x1,y1+radius,2,radius,tpnt);
                      if((segments AND 4)=4) then add_fill_entry(Self, x1,y1-radius,x1-radius,y1,4,radius,tpnt);
                      if((segments AND 8)=8) then add_fill_entry(Self, x1+radius,y1,x1,y1-radius,8,radius,tpnt);
                   end
                else
                   begin
                     WriteArc(Self,oFile);
                   end; { of else }
              end { of if mode = 'A' }
            end; { of if New_Data }
         end;{while not eof}



//******************************************
// deal with all of the polygons           *
//******************************************
   while((high(fills_array)>0) AND (Checkbox20.Checked))do
      begin

         for x:=low(Fills_array) to high(fills_array) do if(Fills_array[x][1].ArcSection = 0) then break;

         next_point:=Fills_array[x][1];
         fill_end:=Fills_array[x][0];
         lastpoint:=fill_end;
         fsa_ptr := 0;
         SetLength(fills_sort_array,0);
         delete_fill_entry(self,x);
         x:=0;
         SetLength(Fills_Sort_array,high(Fills_Sort_Array)+2);
         fills_sort_array[high(Fills_Sort_Array)]:=fill_end;
//******************************************
// copy all of the entries for 1 polygon   *
// into fills_sort_array.                  *
//******************************************
         while(x>=0) do
            begin
               x:= Find_Point(Self,next_point,temp_point);
               if(x>=0) then
                  begin
                      SetLength(Fills_Sort_array,high(Fills_Sort_Array)+2);
                      fills_sort_array[high(Fills_Sort_Array)]:=next_point;
                      Inc(fsa_ptr);
                      next_point := temp_point;
                      delete_fill_entry(self,x);
//******************************************
// if this is the final vertex of this     *
/// polygon, close out the polygon.        *
//******************************************
                      if((next_point.position.x = fill_end.position.x) AND (next_point.position.y = fill_end.position.y))then
                         begin
 // Mark end of sorted array
                            SetLength(Fills_Sort_array,high(Fills_Sort_Array)+2);
// find the boundries and midpoint of the polygon
                            fills_sort_array[high(Fills_Sort_Array)]:=fill_end;
                            fills_sort_array_min_x := 1000000;
                            fills_sort_array_min_y := 1000000;
                            fills_sort_array_max_x := -1000000;
                            fills_sort_array_max_y := -1000000;
                            for y:=low(Fills_Sort_Array) to high(Fills_Sort_Array)do
                               begin
                                  if(Fills_Sort_Array[y].position.x < fills_sort_array_min_x) then fills_sort_array_min_x := Fills_Sort_Array[y].position.x;
                                  if(Fills_Sort_Array[y].position.y < fills_sort_array_min_y) then fills_sort_array_min_y := Fills_Sort_Array[y].position.y;
                                  if(Fills_Sort_Array[y].position.x > fills_sort_array_max_x) then fills_sort_array_max_x := Fills_Sort_Array[y].position.x;
                                  if(Fills_Sort_Array[y].position.y > fills_sort_array_max_y) then fills_sort_array_max_y := Fills_Sort_Array[y].position.y;
                               end;
                            fills_sort_array_mid_x :=  fills_sort_array_min_x + ((fills_sort_array_max_x - fills_sort_array_min_x) div 2);
                            fills_sort_array_mid_y :=  fills_sort_array_min_y + ((fills_sort_array_max_y - fills_sort_array_min_y) div 2);
// Look for pads in the polygon
//memo1.lines.add('-------------------');


//******************************************
// get all of the cut ins, which go in this*
// polygon.                                *
//******************************************
                            PadsInPolygon(self);        // add cut in points to the fills_sort_array


{
  for y:=low(Fills_Sort_Array) to high(Fills_Sort_Array) do
  begin
     memo1.lines.add('x1 = '+IntToStr(Fills_Sort_Array[y].position.x)+
                     ' y1 = '+IntToStr(Fills_Sort_Array[y].position.y)+
                     ' as1 = '+IntToStr(Fills_Sort_Array[y].ArcSection)+
                     ' ar1 = '+IntToStr(Fills_Sort_Array[y].Radius));
  end;
}


//******************************************
// fills_sort_array has a complete polygon *
// write it to the output file.            *
// Add cut ins where found.                *
//******************************************

// write to the gerber
                            lastpoint:=fills_sort_array[y];
//                            InsertFSAEntry(high(Fills_Sort_Array),Fills_Sort_Array[0]);
                            writeln(ofile,'D12*');
                            locs:='D02*';
                            if(NOT(Checkbox22.Checked)) then writeln(ofile,'G36*');
                            for y:=low(Fills_Sort_Array) to high(Fills_Sort_Array) do
                               begin
//******************************************
// deal with arcs while drawing the outline*
//******************************************

                                  If(fills_sort_array[y].ArcSection > 0) then
                                     begin
                                        //writeln(ofile);
                                        if(g74Mode <> 74) then
                                           begin
                                              write(ofile,'G74*');
                                              G74Mode:=74;
                                           end;

//                                        write(ofile,'G01X'+IntToStr(lastpoint.position.x)+'Y'+IntToStr(lastpoint.position.y)+'*');

                                        tpnt := lastpoint.position;

                                        tpnt2 := fills_sort_array[y].position;

                                        dir := ArcDirection(tpnt, tpnt2, fills_sort_array[y].ArcCenter, sa, ea);
                                        if(dir = 1) then locs2:='G02X';
                                        if(dir = 0) then locs2:='G03X';
					write(ofile,locs2+IntToStr(fills_sort_array[y].position.x)+'Y'+IntToStr(fills_sort_array[y].position.y));
                                        i:=abs(lastpoint.position.x - fills_sort_array[y].ArcCenter.x);
                                        j:=abs(lastpoint.position.y - fills_sort_array[y].ArcCenter.y);
                                        writeln(ofile,'I'+IntToStr(i)+'J'+IntToStr(j)+'D01*');
//                                        writeln(ofile,'D02*G01*');
                                        lastpoint:=fills_sort_array[y];
                                     end
                                  else
                                     begin
//******************************************
// If not an arc, just plot the point      *
//******************************************
                                        ArcState:=0;
                                        writeln(ofile,'X'+IntToStr(fills_sort_array[y].position.x)+'Y'+IntToStr(fills_sort_array[y].position.y)+'*'+locs);

                                        if(IsCutIn(fills_sort_array[y],z)) then
                                           begin
      // deal with a cut in - this should never happen
memo1.lines.add('Cut in ???????????');

                                           end; { of it cut in}
                                     end; { of else (Not arc)}
                                  locs:='D01*';
                                  lastpoint:=fills_sort_array[y];
                               end;
                             if(NOT(Checkbox22.Checked)) then writeln(ofile,'D02*G37*');
                         end;
                  end;
            end;

      end;

   writeln(ofile,'M02*');
   CloseFile(Ofile);
   CloseFile(ifile);
end;


{-----------------------------------------------------------------------}
//  write aperture list
procedure TForm6.Write_Apts;
var
apt_ptr,
xs,ys,dc     :Integer;
xss,yss,
xss1,xss2,
tss1,
temps,
inbuf              :String;
locs,locs2         :String;
xf,xf2,xf3         :Real;
begin
       for apt_ptr:=0 to 1000 do apts[apt_ptr].shape :=-1;
       apt_ptr := 0;
       Assignfile(ifile,APT_File_Name);
       RESET(ifile);
       writeln(ofile,'G04 Format statement*');
       writeln(ofile,'%FSLAX23Y23*%');
       writeln(ofile,'%MOIN*%');
       writeln(ofile,'G04 Apeture information*');
//process aperture file
       While (Not EOF(ifile)) do
           begin
              readln(ifile,inbuf);

              aptline(inbuf,dc,temps,xs,ys);
              xss:=IntToStr(xs MOD 1000);
              while (length(xss)<3) do xss:='0'+xss;
              xss1:=IntToStr(xs div 2);
              tss1:=IntToStr(xs+20);
              while (length(xss1)<3) do xss1:='0'+xss1;
              while (length(tss1)<3) do tss1:='0'+tss1;
              xss2:=IntToStr(xs div 4);
              while (length(xss2)<3) do xss2:='0'+xss2;
              yss:=IntToStr(ys MOD 1000);
              while (length(yss)<3) do yss:='0'+yss;

              xss:='.'+xss;
              yss:='.'+yss;
              if(ys>=1000) then yss:=IntToStr(ys div 1000)+yss;
              if(xs>=1000) then xss:=IntToStr(xs div 1000)+xss;

              if temps='CIRCULAR' then
                 begin
                    writeln(ofile,'%ADD',dc,'C,',xss,'*%');
                    apts[apt_ptr].shape := 1;
                    apts[apt_ptr].x := xs;
                    apts[apt_ptr].y := ys;
                    apts[apt_ptr].d_code := dc;
                    Inc(Apt_Ptr);
                 end;

              if temps='RECTANGULAR' then
                 begin
                    writeln(ofile,'%ADD',dc,'R,',xss,'X',yss,'*%');
                    apts[apt_ptr].shape := 2;
                    apts[apt_ptr].x := xs;
                    apts[apt_ptr].y := ys;
                    apts[apt_ptr].d_code := dc;
                    Inc(Apt_Ptr);
                 end;
              if temps='ROUNDRECT' then
                 begin
                    writeln(ofile,'%ADD',dc,'O,',xss,'X',yss,'*%');
                    apts[apt_ptr].shape := 4;
                    apts[apt_ptr].x := xs;
                    apts[apt_ptr].y := ys;
                    apts[apt_ptr].d_code := dc;
                    Inc(Apt_Ptr);
                 end;
              if temps='OCTAGONAL' then
                 begin
                    writeln(ofile,'%ADD',dc,'P,',xss,'X8X22.5*%');
                    apts[apt_ptr].shape := 3;
                    apts[apt_ptr].x := xs;
                    apts[apt_ptr].y := ys;
                    apts[apt_ptr].d_code := dc;
                    Inc(Apt_Ptr);
                 end;
              if temps='MOIRE' then
                 begin
                    xf := xs;
                    xf:=xf/1000;
                    xf2:=xf/10;
                    locs:=FloatToStrF(xf2,fffixed,3,3);
                    write(ofile,'%AMMOIRE',xs,'*6,0,0,',xss,',');
                    write(ofile,locs,',');    // circle width
                    write(ofile,locs,',');    // gap width
                    write(ofile,'5');         // number of cirles
                    writeln(ofile,',0,0,0*%');    // cr4osshairs, rotation

                    writeln(ofile,'%ADD',dc,'MOIRE',xs,'*%');
                    apts[apt_ptr].shape := 6;
                    apts[apt_ptr].x := xs;
                    apts[apt_ptr].y := ys;
                    apts[apt_ptr].d_code := dc;
                    Inc(Apt_Ptr);
                 end;
              if temps='CROSSHAIR' then
                 begin
                    xf := xs;
                    xf:=xf/1000;
                    xf2:=xf;
                    xf3:=xf/20;
                    locs:=FloatToStrF(xf2,fffixed,3,3);
                    locs2:=FloatToStrF(xf3,fffixed,3,3);
                    writeln(ofile,'%AMCROSSHAIR',xs,'*21,1,',locs,',',locs2,',0,0*21,1,',locs2,',',locs,',0,0*%');
                    writeln(ofile,'%ADD',dc,'CROSSHAIR',xs,'*%');
                    apts[apt_ptr].shape := 5;
                    apts[apt_ptr].x := xs;
                    apts[apt_ptr].y := ys;
                    apts[apt_ptr].d_code := dc;
                    Inc(Apt_Ptr);
                 end;
              if temps='RELIEF' then
                 begin
//                 writeln(ofile,'%AMTHERM',xs,'*7,0,0,.',xss,',.',xss1,',.',xss2,',0*%');
                    write(ofile,'%AMTHERM',xs,'*7,0,0,.',tss1,',',xss,',.');
                    locs:=IntToStr(xs div 3);
                    while(length(locs)<3) do locs:='0'+locs;
                    write(ofile,locs);
                    writeln(ofile,',0*%');
                    writeln(ofile,'%ADD',dc,'THERM',xs,'*%');
                    apts[apt_ptr].shape := 7;
                    apts[apt_ptr].x := xs;
                    apts[apt_ptr].y := ys;
                    apts[apt_ptr].d_code := dc;
                    Inc(Apt_Ptr);
                 end;
//              writeln(ofile,inbuf);
           end;   {of  while (Not EOF(ifile)) do}
       closefile(ifile);
       writeln(ofile,'G04 End of apeture information*');
end; {of procedue}
{-----------------------------------------------------------------------}
procedure Aptline(line:string; var dcode:integer;
                               var shape :string;
                               var xsize  :integer;
                               var ysize  :integer);
var
locy,
locx,
locz  :Integer;
begin
locx:=2; dcode:=0; xsize:=0; ysize:=0; shape:='';
while (is_sep(line[locx])=False) do
   begin
      val(line[locx],locy,locz);
      dcode:=(dcode*10)+locy;
      locx:=Locx+1;
   end;

   while (is_sep(line[locx])=True) do locx:=locx+1;

   while (is_sep(line[locx])=False) do
   begin
      shape:=shape+line[locx];
      locx:=Locx+1;
   end;
   shape:=uppercase(shape);

   while (is_num(line[locx])=False) do locx:=locx+1;

while (is_sep(line[locx])=False) do
   begin
      val(line[locx],locy,locz);
      xsize:=(xsize*10)+locy;
      locx:=Locx+1;
   end;

   while (is_num(line[locx])=False) do locx:=locx+1;

while (is_sep(line[locx])=False) do
   begin
      val(line[locx],locy,locz);
      ysize:=(ysize*10)+locy;
      locx:=Locx+1;
   end;

end;
{----------------------------------------------}
procedure reset_data;
begin
x1:=-1;
x2:=-1;
y1:=-1;
y2:=-1;
layer:=-1;
cheight:=-1;
cwidth:=-1;
linewidth:=-1;
diameter:=-1;
radius := -1;
holesize:=-1;
padnum:=-1;
plane:=-1;
shape:=-1;
rotation:=-1;
fillx:=-1;
filly:=-1;
segments:=-1;
ctext:='';
end;
{----------------------------------------------}
procedure GetFill(LocS:String);
var
x         :Integer;
begin
  x:=1;
  x1    :=getbin(LocS, x);
  y1    :=getbin(LocS, x);
  x2    :=getbin(LocS, x);
  y2    :=getbin(LocS, x);
  layer :=getbin(LocS, x);
  fillx:=abs(x1-x2);
  filly:=abs(y1-y2);
end;
{---------------------------------------------------}
procedure GetTrack(LocS:String);
var
x         :Integer;
begin
  d_code := -1;
  x:=1;
  x1        :=getbin(LocS, x);
  y1        :=getbin(LocS, x);
  x2        :=getbin(LocS, x);
  y2        :=getbin(LocS, x);
  linewidth :=getbin(LocS, x);
  layer     :=getbin(LocS, x);
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 1) then continue;
        if(apts[x].x <> linewidth) then continue;
        if(apts[x].y <> linewidth) then continue;
        d_code := apts[x].d_code;
        break;
     end;
end;
{---------------------------------------------------}
procedure GetVia(LocS:String);
var
x         :Integer;
begin
  d_code := -1;
  s_mask_d_code := -1;
  p_mask_d_code := -1;
  plane_d_code := -1;
  x:=1;
  x1      :=getbin(LocS, x);
  y1      :=getbin(LocS, x);
  diameter:=getbin(LocS, x);
  holesize:=getbin(LocS, x);
  layer := MULTI_LAYER;
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 1) then continue;
        if(apts[x].x <> diameter) then continue;
        if(apts[x].y <> diameter) then continue;
        d_code := apts[x].d_code;
        break;
     end;
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 1) then continue;
        if(apts[x].x <> (diameter+SolderMaskEnlargement)) then continue;
        if(apts[x].y <> (diameter+SolderMaskEnlargement)) then continue;
        s_mask_d_code := apts[x].d_code;
        break;
     end;
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 1) then continue;
        if(apts[x].x <> (diameter+PlaneEnlargement)) then continue;
        if(apts[x].y <> (diameter+PlaneEnlargement)) then continue;
        plane_d_code := apts[x].d_code;
        break;
     end;
end;
{---------------------------------------------------}
procedure GetPad(LocS:String);
var
x         :Integer;
tempstr   :String;
begin
  d_code := -1;
  s_mask_d_code := -1;
  p_mask_d_code := -1;
  plane_d_code := -1;
  pwr_d_code := -1;
  gnd_d_code := -1;
  x:=1;
  x1      :=getbin(LocS, x);
  y1      :=getbin(LocS, x);
  cwidth   :=getbin(LocS, x);
  cheight  :=getbin(LocS, x);
  shape   :=getbin(LocS, x);
  holesize:=getbin(LocS, x);
  plane   :=getbin(LocS, x);
  layer   :=getbin(LocS, x);
  readln(ifile,tempstr);
  val(tempstr,padnum,x);
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> shape) then continue;
        if(apts[x].x <> cwidth) then continue;
        if(apts[x].y <> cheight) then continue;
        d_code := apts[x].d_code;
        break;
     end;
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> shape) then continue;
        if(apts[x].x <> (cwidth+SolderMaskEnlargement)) then continue;
        if(apts[x].y <> (cheight+SolderMaskEnlargement)) then continue;
        s_mask_d_code := apts[x].d_code;
        break;
     end;
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> shape) then continue;
        if(apts[x].x <> (cwidth+PasteMaskEnlargement)) then continue;
        if(apts[x].y <> (cheight+PasteMaskEnlargement)) then continue;
        p_mask_d_code := apts[x].d_code;
        break;
     end;
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 1) then continue;
        if(apts[x].x <> (cwidth+PlaneEnlargement)) then continue;
        if(apts[x].y <> (cheight+PlaneEnlargement)) then continue;
        plane_d_code := apts[x].d_code;
        break;
     end;
  if(plane = 2) then
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 7) then continue;
        if(apts[x].x <> cwidth) then continue;
        if(apts[x].y <> cheight) then continue;
        gnd_d_code := apts[x].d_code;
        break;
     end;
  if(plane = 4) then
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 7) then continue;
        if(apts[x].x <> cwidth) then continue;
        if(apts[x].y <> cheight) then continue;
        pwr_d_code := apts[x].d_code;
        break;
     end;
  if(plane = 3) then  gnd_d_code := 0;          // direct to gnd plane
  if(plane = 5) then  pwr_d_code := 0;          // direct to power plane


end;
{---------------------------------------------------}
procedure GetComponent(var iFile :Textfile);
var
x         :Integer;
locs      :String;
begin

   readln(iFile,ref_des_str);   // get ref des
   readln(iFile,pattern_str);   // get pattern
   readln(iFile,Comment_str);   // get comment
// need to make sure we have the appropriate apertures for these strings

   readln(iFile,locs);   // get comment information
   locs:=trim(locs);
   locs:=locs+' ';
   x:=1;
   comment_x :=getbin(locs, x);
   comment_y :=getbin(locs, x);
   comment_height :=getbin(locs, x);
   comment_direction :=getbin(locs, x);
   comment_width :=getbin(locs, x);
   comment_layer :=getbin(locs, x);

   readln(iFile,locs);   // get ref des information
   locs:=trim(locs);
   locs:=locs+' ';
   x:=1;
   ref_des_x :=getbin(locs, x);
   ref_des_y :=getbin(locs, x);
   ref_des_height :=getbin(locs, x);
   ref_des_direction :=getbin(locs, x);
   ref_des_width :=getbin(locs, x);
   ref_des_layer :=getbin(locs, x);

   readln(iFile,locs);   // get component information
   locs:=trim(locs);
   locs:=locs+' ';
   x:=1;
   comp_hide_ref :=getbin(locs, x);
   comp_hide_ref :=getbin(locs, x);
   comp_hide_ref :=getbin(locs, x);
   comp_hide_comment :=getbin(locs, x);
   comp_locked :=getbin(locs, x);
   for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 1) then continue;
        if(apts[x].x <> ref_des_width) then continue;
        if(apts[x].y <> ref_des_width) then continue;
        ref_des_d_code := apts[x].d_code;
        break;
     end;
   for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 1) then continue;
        if(apts[x].x <> comment_width) then continue;
        if(apts[x].y <> comment_width) then continue;
        comment_d_code := apts[x].d_code;
        break;
     end;

end;
{---------------------------------------------------}
procedure GetArc(LocS:String);
var
x         :Integer;
begin
  d_code := -1;
  x:=1;
  x1       :=getbin(LocS, x);
  y1       :=getbin(LocS, x);
  radius   :=getbin(LocS, x);
  segments :=getbin(LocS, x);
  linewidth:=getbin(LocS, x);
  layer    :=getbin(LocS, x);
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 1) then continue;
        if(apts[x].x <> linewidth) then continue;
        if(apts[x].y <> linewidth) then continue;
        d_code := apts[x].d_code;
        break;
     end;
end;
{---------------------------------------------------}
procedure GetString(LocS:String);
var
x         :Integer;
begin
  x:=1;
  x1       :=getbin(LocS, x);
  y1       :=getbin(LocS, x);
  cheight   :=getbin(LocS, x);
  rotation :=getbin(LocS, x);
  linewidth:=getbin(LocS, x);
  layer   :=getbin(LocS, x);
  readln(ifile,ctext);
  for x:=0 to 1000 do
     begin
        if(apts[x].shape = -1) then break;
        if(apts[x].shape <> 1) then continue;
        if(apts[x].x <> linewidth) then continue;
        if(apts[x].y <> linewidth) then continue;
        d_code := apts[x].d_code;
        break;
     end;
end;
{----------------------------------------------}
function getbin(LocS :string; var LocX:Integer):integer;
var
tempstr  :String;
x,z      :Integer;
begin
  While (Is_sep(LocS[LocX])=True) do LocX:=LocX+1;
  While (Is_sep(LocS[LocX])=False)do
  begin
     tempstr:=tempstr+LocS[LocX];
     LocX:=LocX+1;
  end;
  val(Tempstr,x,z);
  getbin:=x;
end;
{----------------------------------------------}
//----------------------------------------------------------------------------
procedure TForm6.CreateNCDrill(Sender :TObject);
var
NewData :Boolean;
x         :Integer;
locs      :String;
temp_drill:drill_rec;
last_drill_size,
tool_ptr,
drill_ptr :Integer;
begin
//   drill_ptr := 0;
   SetLength(drill_array,0);
   Memo1.lines.add('NC Drill');
   Assignfile(ofile,BASE_File_Name+'.TXT');
   ReWrite(ofile);
   Assignfile(ifile,PCB_File_Name);
   RESET(ifile);



 //************************
 // process file, get all *
 // holes and mark them   *
 //************************

         while(not EOF(ifile)) do
         begin
            readln(ifile,inbuf);
            reset_data;
// Pads
            if ((inbuf='CP')OR(inbuf='FP')) then
               begin
                  readln(ifile,inbuf);
                  GetPad(inbuf+' ');
                  if(layer = MULTI_LAYER) then
                     begin
                       SetLength(drill_array,high(drill_array)+2);
                       drill_array[high(drill_array)].x := x1;
                       drill_array[high(drill_array)].y := y1;
                       drill_array[high(drill_array)].size := HoleSize;
                       Inc(drill_ptr);
                     end;
               end
// vias
            else if ((inbuf='CV')OR(inbuf='FV')) then
               begin
                  readln(ifile,inbuf);
                  GetVia(inbuf+' ');
                  if(layer = MULTI_LAYER) then
                     begin
                       SetLength(drill_array,high(drill_array)+2);
                       drill_array[high(drill_array)].x := x1;
                       drill_array[high(drill_array)].y := y1;
                       drill_array[high(drill_array)].size := HoleSize;
//                       Inc(drill_ptr);
                     end;
               end
// throw away component headers, sting could have CP/CV/FP/FV
           else if (inbuf='COMP') then
               begin
                  GetComponent(iFile);
               end
// throw away strings, sting could have CP/CV/FP/FV
            else if ((inbuf='CS')OR(inbuf='FS')) then
               begin
                  readln(ifile,inbuf);   // throw away string
               end;
         end;{while not eof}

//***************************************
// Check for duplicate drill hits at    *
// same x-y.                            *
//***************************************

//***************************************
// sort the drill table by x : y        *
//***************************************
     repeat
        NewData := False;
        for x:=low(drill_array) to (high(drill_array)-1) do
           begin
              if(drill_array[x].x > drill_array[x+1].x)then
                 begin
                    temp_drill := drill_array[x];
                    drill_array[x] :=drill_array[x+1];
                    drill_array[x+1] := temp_drill;
                    NewData := True;
                 end
              else if((drill_array[x].x = drill_array[x+1].x)AND
                      (drill_array[x].y > drill_array[x+1].y))then
                 begin
                    temp_drill := drill_array[x];
                    drill_array[x] :=drill_array[x+1];
                    drill_array[x+1] := temp_drill;
                    NewData := True;
                 end;
           end;
     until(NewData = False);

//***************************************
// check for duplicates                 *
//***************************************
     for x:=low(drill_array) to (high(drill_array)-1) do
        begin
           if((drill_array[x].x = drill_array[x+1].x)AND
              (drill_array[x].y = drill_array[x+1].y))then
                  begin
                     Memo1.lines.add('WARNING: Multiple drill hits at '+IntToStr(drill_array[x].x)+'x'+IntToStr(drill_array[x].y));
                     beep;
                  end;
        end;

//***************************************
// sort the drill table by tool : x : y *
//***************************************
     repeat
        NewData := False;
        for x:=low(drill_array) to (high(drill_array)-1) do
           begin
              if(drill_array[x].size > drill_array[x+1].size) then
                 begin
                    temp_drill := drill_array[x];
                    drill_array[x] :=drill_array[x+1];
                    drill_array[x+1] := temp_drill;
                    NewData := True;
                 end
              else if((drill_array[x].size = drill_array[x+1].size) AND
                      (drill_array[x].x > drill_array[x+1].x))then
                 begin
                    temp_drill := drill_array[x];
                    drill_array[x] :=drill_array[x+1];
                    drill_array[x+1] := temp_drill;
                    NewData := True;
                 end
              else if((drill_array[x].size = drill_array[x+1].size) AND
                      (drill_array[x].x = drill_array[x+1].x)AND
                      (drill_array[x].y > drill_array[x+1].y))then
                 begin
                    temp_drill := drill_array[x];
                    drill_array[x] :=drill_array[x+1];
                    drill_array[x+1] := temp_drill;
                    NewData := True;
                 end;
           end;
     until(NewData = False);

//************************
// write the drill header*
//************************
   writeln(ofile,'M48');        //Program Header
   writeln(ofile,'M72');        //English measurement
   for x:=low(unit3.drills) to high(unit3.drills) do
      begin
         locs:=IntToStr(x+1);
         if(length(locs)<2) then locs:='0'+locs;
         write(ofile,'T'+locs+'C');
         locs:=IntToStr(Unit3.drills[x][1] div 1000);
         write(ofile,locs+'.');
         locs:=IntToStr(Unit3.drills[x][1] MOD 1000);
         while(length(locs)<3) do locs:='0'+locs;
         writeln(ofile,locs);
      end;
   writeln(ofile,'%');          // end of header

//************************
// write the drill table *
//************************
   last_drill_size := -1;
   tool_ptr := 0;
   for drill_ptr:=low(drill_array) to high(drill_array) do
      begin
         if(drill_array[drill_ptr].size <> last_drill_size) then // new size
            begin
               last_drill_size := Unit3.drills[tool_ptr][1];
               Inc(tool_ptr);
               locs:=IntToStr(tool_ptr);
               if(length(locs)<2) then locs:='0'+locs;
               writeln(ofile,'T'+locs);
            end;
         locs:=IntToStr(drill_array[drill_ptr].x);
         while(length(locs)<5) do locs:='0'+locs;
         write(ofile,'X'+locs);
         locs:=IntToStr(drill_array[drill_ptr].y);
         while(length(locs)<5) do locs:='0'+locs;
         writeln(ofile,'Y'+locs);
      end;
   writeln(ofile,'T00');        // unload tool
   writeln(ofile,'M30');        // end of file
   CloseFile(Ofile);
   CloseFile(ifile);
end;


//----------------------------------------------------------------------------
procedure TForm6.CreateBOM(Sender :TObject);
var
rptr,
x         :Integer;
typelist  :TStringList;
reflists  :Array [0..100000] of TStringlist;

begin
   Memo1.lines.add('BOM');
   Assignfile(ofile,BASE_File_Name+'.csv');
   ReWrite(ofile);
   Assignfile(ifile,PCB_File_Name);
   RESET(ifile);

   typelist := TStringList.Create;



 //************************
 // process file, get all *
 // holes and mark them   *
 //************************

         while(not EOF(ifile)) do
         begin
            readln(ifile,inbuf);
            reset_data;
// pads
            if ((inbuf='CP')OR(inbuf='FP')) then
               begin
                  readln(ifile,inbuf);
                  GetPad(inbuf+' ');
               end
// arcs
            else if ((inbuf='CA')OR(inbuf='FA')) then
               begin
                  readln(ifile,inbuf);
                  GetArc(inbuf+' ');
               end
// tracks
            else if ((inbuf='CT')OR(inbuf='FT')) then
               begin
                  readln(ifile,inbuf);
                  GetTrack(inbuf+' ');
                  if(layer=6) then
                  begin
                  end;
               end
// fills
            else if ((inbuf='CF')OR(inbuf='FF')) then
               begin
                  readln(ifile,inbuf);
                  GetFill(inbuf+' ');
               end
// do strings
            else if ((inbuf='CS')OR(inbuf='FS')) then
               begin
                  readln(ifile,inbuf);
                  GetString(inbuf+' ');
               end
// do components
            else if (inbuf='COMP') then
               begin
                   GetComponent(iFile);
                   typelist.Sort;
                   if(typelist.Find(Comment_str,x) = False) then typelist.Add(Comment_str);
                end;
         end;
   typelist.Sort;

//***************************************************
// The comment tstringList is built and sortred     *
// get the ref des's for each part and write them   *
//***************************************************

//******************************************************************************
// create the appropriate number of stringlists (one for each component type)  *
//******************************************************************************
   for x:=0 to (typelist.Count-1) do reflists[x] := TStringList.Create;


//***************************************************
// Process the file again, place each ref des with  *
// the correct component.                           *
//***************************************************

    Reset(iFile);

     while(not EOF(ifile)) do
     begin
        readln(ifile,inbuf);
        reset_data;
  // pads
        if ((inbuf='CP')OR(inbuf='FP')) then
           begin
              readln(ifile,inbuf);
              GetPad(inbuf+' ');
           end
  // arcs
        else if ((inbuf='CA')OR(inbuf='FA')) then
           begin
              readln(ifile,inbuf);
              GetArc(inbuf+' ');
           end
  // tracks
        else if ((inbuf='CT')OR(inbuf='FT')) then
           begin
              readln(ifile,inbuf);
              GetTrack(inbuf+' ');
              if(layer=6) then
              begin
              end;
           end
  // fills
        else if ((inbuf='CF')OR(inbuf='FF')) then
           begin
              readln(ifile,inbuf);
              GetFill(inbuf+' ');
           end
  // do strings
        else if ((inbuf='CS')OR(inbuf='FS')) then
           begin
              readln(ifile,inbuf);
              GetString(inbuf+' ');
           end
  // do components
        else if (inbuf='COMP') then
           begin
               GetComponent(iFile);
               if(typelist.Find(Comment_str,x) = True) then
                  begin
                     reflists[x].Add(ref_des_str);
                  end;
            end;
     end;

//***************************************************
// combind "reflists are done - write file          *
//***************************************************

   if(typelist.Count > 0) then
      for rptr:=0 to (typelist.Count-1) do
         begin
             RefLists[rptr].Sort;
             Write(oFile,'"'+Typelist.Strings[rptr]+'",'+IntToStr(RefLists[rptr].Count)+',"');
                for x:= 0 to (RefLists[rptr].Count-1) do
                   begin
                      Write(oFile,Reflists[rptr].Strings[x]);
                      if(x < (Reflists[rptr].Count-1)) then Write(oFile,',');
                   end;
                Writeln(oFile,'"');
         end;
// all done

   for x:=0 to (typelist.Count-1) do reflists[x].Free;
   typelist.Free;
   CloseFile(Ofile);
   CloseFile(ifile);
end;

{-----------------------------------------------------------------------------}
procedure TForm6.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SaveRegistry(Self);
end;
{-----------------------------------------------------------------------------}
procedure TForm6.FormCreate(Sender: TObject);
begin
   ReadRegistry(Self);
end;
{-----------------------------------------------------------------------------}
procedure TForm6.SaveRegistry(Sender: TObject);
var
   Registry: TRegistry;
   locs:string;
   x, z: integer;
   Temp    :TComponent;
begin
   Registry:= TRegistry.Create;
   with Registry do
      begin
          if OpenKey( REGNAME6, True ) then for x:=0 to (form6.ComponentCount-1) do
            begin
               if(form6.Components[x] is tCheckBox) then
                  begin
                     Temp:=form6.Components[x];
                     with Temp as TCheckBox do
                        begin
                           z:= (Temp as TCheckBox).Tag;
                           if(z=0) then continue;
                           locs:='CheckBox'+IntToStr(z);
                           Registry.WriteBool(locs,(form6.Components[x] as TCheckBox).Checked);
                        end;
                  end;
            end;
         Registry.WriteInteger('FormX',Form6.Left);
         Registry.WriteInteger('FormY',Form6.Top);
      end;
end;


{-----------------------------------------------------------------------------}
procedure TForm6.ReadRegistry(Sender: TObject);
var
   Registry: TRegistry;
   locs:string;
   x, z: integer;
   Temp    :TComponent;
begin
   Registry:= TRegistry.Create;
   with Registry do begin
      if (OpenKey( REGNAME6, False )=True) then
       begin
         for x:=0 to (form6.ComponentCount-1) do
            begin
               if(form6.Components[x] is tCheckBox) then
                  begin
                     Temp:=form6.Components[x];
                     with Temp as TCheckBox do
                        begin
                           z:= (Temp as TCheckBox).Tag;
                           if(z=0) then continue;
                           locs:='CheckBox'+IntToStr(z);
                           if(Registry.ValueExists(locs)) then
                              (form6.Components[x] as TCheckBox).Checked := Registry.ReadBool(locs);
                        end;
                  end;
            end;
         if(Registry.ValueExists('FormX')) then form6.Left := Registry.ReadInteger('FormX');
         if(Registry.ValueExists('FormY')) then form6.Top := Registry.ReadInteger('FormY');
       end ;
      CloseKey;
   end;
   Registry.Free;
end;
{-----------------------------------------------------------------------------}

procedure TForm6.PlaceDrillMark(Sender :TObject; var oFile :TextFile; x :Integer; y :Integer; h :Integer; d_code :Integer);
var
xstr,ystr,
ostr  :String;
tool,
scale,
last_o,
o,
lx,
ix,iy   :Integer;
begin
   for tool := low(Unit3.drills) to high(Unit3.drills) do
      begin
         if(Unit3.drills[tool][1]= h) then break          // found size
      end;
//    memo1.lines.add(IntToStr(h)+' - '+IntToStr(tool));
   scale:=40;
   last_o := -1;
   ix:=x;
   iy:=y;
   if(last_d_code <> d_code) then
      begin
         last_d_code := d_code;
         Write(oFile,'D'+IntToStr(d_code)+'*');
      end;
   if(tool<32) then
      begin
         for lx:= 0 to 5 do
            begin
               if(DrillSquare[lx].on_off = 3) then break;
               x:=ix+(DrillSquare[lx].x1*scale);
               y:=iy+(DrillSquare[lx].y1*scale);
               o:=DrillSquare[lx].on_off;
               xstr:=IntToStr(x);
               ystr:=IntToStr(y);
               if(o<>last_o)then
                  begin
                     ostr:=IntToStr(o);
                     while(length(ostr)<2) do ostr:='0'+ostr;
                     ostr:='D'+ostr+'*';
                     last_o := o;
                     write(oFile,ostr);
                  end;
               write(oFile,'X'+xstr+'Y'+ystr+'*');
            end;
         write(oFile,'D02*');
      end
   else
      begin
         write(oFile,'G75*G01X'+IntToStr(ix-scale)+'Y'+IntToStr(iy)+'D02*G03X'+IntToStr(ix-scale)+'Y'+IntToStr(iy)+'I'+IntToStr(scale)+'J0D01*G01X'+IntToStr(ix-scale)+'Y'+IntToStr(iy+scale)+'D02*');
         tool:=tool-32;
      end;
   for lx:= 0 to 2 do
      begin
         if(DrillSymbols[tool][lx].on_off = 3) then break;
         x:=ix+(DrillSymbols[tool][lx].x1*scale);
         y:=iy+(DrillSymbols[tool][lx].y1*scale);
         o:=DrillSymbols[tool][lx].on_off;
         xstr:=IntToStr(x);
         ystr:=IntToStr(y);
         if(o<>last_o)then
            begin
               ostr:=IntToStr(o);
               while(length(ostr)<2) do ostr:='0'+ostr;
               ostr:='D'+ostr+'*';
               last_o := o;
               write(oFile,ostr);
            end;
         write(oFile,'X'+xstr+'Y'+ystr+'*');
      end;
   writeln(oFile,'D02*');

   end;

//----------------------------------------------------------------------------
procedure TForm6.CreateGDDGerber(Sender :TObject; id :Integer);
var
locs      :String;
tool,
legend_x,
legend_y,
dd_d_code,
dim_line_offset:Integer;
tempf   :Real;

begin
   dd_d_code := 11;
   dim_line_offset := 125;
   legend_x:=PCB_Max_X+ dim_line_offset + 500;
   legend_y:=PCB_Max_Y -50;
   Memo1.lines.add(FileNames[id]);
   Assignfile(ofile,BASE_File_Name+FileNames[id]);
   ReWrite(ofile);
   Write_Apts;
   Assignfile(ifile,PCB_File_Name);
   RESET(ifile);

         while(not EOF(ifile)) do
         begin
            readln(ifile,inbuf);
            reset_data;
            if ((inbuf='CP')OR(inbuf='FP')) then
               begin
                  readln(ifile,inbuf);
                  GetPad(inbuf+' ');
                  if (layer = MULTI_LAYER) then PlaceDrillMark(Self, oFile, x1,y1, holesize,dd_d_code);
               end { of pads}
            else if ((inbuf='CV')OR(inbuf='FV')) then
               begin
                  readln(ifile,inbuf);
                  GetVia(inbuf+' ');
                  if (layer = MULTI_LAYER) then PlaceDrillMark(Self, oFile, x1,y1, holesize,dd_d_code);
               end { of vias}
           else if ((inbuf='CT')OR(inbuf='FT')) then
               begin
                  readln(ifile,inbuf);
                  GetTrack(inbuf+' ');
                  if (layer = BOARD_LAYER) then
                  begin
                     if(last_d_code <> d_code) then
                        begin
                           last_d_code := d_code;
                           Write(ofile,'D'+IntToStr(d_code)+'*');
                        end;
                      writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');
                  end;
               end {of tracks}
            else if ((inbuf='CS')OR(inbuf='FS')) then
               begin
                  readln(ifile,inbuf);
                  GetString(inbuf+' ');
               end {of strings}
            else if (inbuf='COMP') then
               begin
                  GetComponent(iFile);
               end {of components}
            else if ((inbuf='CA')OR(inbuf='FA')) then
               begin
                  readln(ifile,inbuf);
                  GetArc(inbuf+' ');
                  if (layer <> BOARD_LAYER) then continue;
                  WriteArc(Self,oFile);
            end; {of arcs}

         end;{while not eof}



   d_code := dd_d_code;
   if(last_d_code <> d_code) then
      begin
         last_d_code := d_code;
         Write(ofile,'D'+IntToStr(d_code)+'*');
      end;
// draw top dimention line
   x1:=PCB_Min_X;
   y1:=PCB_Max_Y + dim_line_offset;
   x2:=PCB_Max_X;
   y2:=PCB_Max_Y + dim_line_offset;
   writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');
// left arrow
// top half
   x2:=PCB_Min_X+50;
   y2:=PCB_Max_Y + dim_line_offset+50;
   writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');
// bottom half
   y2:=PCB_Max_Y + dim_line_offset-50;
   writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');
// right arrow
// top half
   x1:=PCB_Max_X;
   y1:=PCB_Max_Y + dim_line_offset;
   x2:=PCB_Max_X-50;
   y2:=PCB_Max_Y + dim_line_offset+50;
   writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');
// bottom half
   y2:=PCB_Max_Y + dim_line_offset-50;
   writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');

// draw right dimention line
   x1:=PCB_Max_X+dim_line_offset;
   y1:=PCB_Min_Y;
   x2:=PCB_Max_X+dim_line_offset;
   y2:=PCB_Max_Y;
   writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');
// top arrow
// left half
   y1:=PCB_Max_Y;
   x2:=PCB_Max_X+dim_line_offset-50;
   y2:=PCB_Max_Y - 50;
   writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');
// right half
   x2:=PCB_Max_X+dim_line_offset+50;
   writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');
// bottom arrow
// left half
   y1:=PCB_Min_Y;
   x2:=PCB_Max_X+dim_line_offset -50;
   y2:=PCB_Min_Y+50;
   writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');
// right half
   x2:=PCB_Max_X+dim_line_offset+50;
   writeln(ofile,'D02*X'+IntToStr(x1)+'Y'+IntToStr(y1)+'*D01*'+'X'+IntToStr(x2)+'Y'+IntToStr(y2)+'*D02*');

   tempf := PCB_Max_X - PCB_Min_X;
   tempf := tempf /1000;
   locs:=FloatToStrf(tempf,fffixed,4,3)+'"';
   WriteGerberString(Self, oFile,  ((PCB_Max_X - PCB_Min_X) div 2)+PCB_Min_X - 50, PCB_Max_Y + dim_line_offset + 25, dd_d_code,locs,48,0);

   tempf := PCB_Max_Y - PCB_Min_Y;
   tempf := tempf /1000;
   locs:=FloatToStrf(tempf,fffixed,4,3)+'"';
   WriteGerberString(Self, oFile, PCB_Max_X + dim_line_offset + 25, ((PCB_Max_Y - PCB_Min_Y) div 2)+PCB_Min_Y, dd_d_code,locs,48,0);

//**************
// Draw legend *
//**************

   for tool:=low(unit3.drills) to high(unit3.drills) do
      begin
         PlaceDrillMark(Self, oFile, legend_x,legend_y, Unit3.drills[tool][1],dd_d_code);
         tempf := Unit3.drills[tool][1];
         tempf := tempf /1000;
         locs:=FloatToStrf(tempf,fffixed,4,3)+'"  '+IntToStr(Unit3.drills[tool][2]);;
         WriteGerberString(Self, oFile, legend_x+100, legend_y-25, dd_d_code,locs,48,0);
         legend_y := legend_y - 150;
         if(legend_y < 150) then
            begin
               legend_y:=PCB_Max_Y -50;
               legend_x:=legend_x+750;
            end;
      end;

   writeln(ofile,'M02*');
   CloseFile(Ofile);
   CloseFile(ifile);
end;
{-----------------------------------------------------------------------------}
procedure TForm6.WriteGerberString(Sender :TObject; var oFile :TextFile; x :Integer; y :Integer; d_code :Integer; data :String; theight :Integer; direction :Integer);
var
lx        :Integer;
ltp       :TPoint;
begin
   for lx:=1 to length(data) do
      begin
         ltp:=WriteGerberChar(Self, oFile ,x ,y ,d_code,data[lx],theight,direction);
         x:=x+ltp.x;
         y:=y+ltp.y;
      end;
end;
{-----------------------------------------------------------------------------}

function TForm6.WriteGerberChar(Sender :TObject; var oFile :TextFile; x :Integer; y :Integer; d_code :Integer; data :Char; theight :Integer; direction :Integer):TPoint;
var
xscale,
yscale,
rotated,
w,
tx,ty,td,
p,e,
last_o,
ix,iy   :Integer;
begin
   Result.x := 0;
   Result.y := 0;
   rotated := 0;
   xscale := theight div 6;
   yscale := theight div 6;
   if((direction and 16) = 16) then xscale:=0-xscale;
   if((direction and $02) = 2) then
      begin
         xscale:=0-xscale;
         yscale:=0-yscale;
      end;
   if((direction and $01) = 1) then
      begin
          yscale:=0-yscale;
          rotated := 1;
      end;

   if((direction = 17) OR (direction = 19)) then
      begin
         xscale:=0-xscale;
         yscale:=0-yscale;
      end;
   ix:=x;
   iy:=y;
   if(last_d_code <> d_code) then
      begin
         last_d_code := d_code;
         Write(oFile,'D'+IntToStr(d_code)+'*');
      end;
   p:=Ord(data)-$20;
   w:=CharWidths[p];
   e:=CharPtrs[p+1];
   p:=CharPtrs[p];

   last_o := 2;
   Write(oFile,'D02*');

   if(rotated = 0) then
      begin
         tx:=CharData[p];
         Inc(p);
         ty:=CharData[p];
         Inc(p);
         Inc(p);
         x:=ix+(tx*xscale);
         y:=iy+(ty*yscale);
         Write(oFile,'X'+IntToStr(x)+'Y'+IntToStr(y)+'*');
         while(p<e) do
            begin
               tx:=CharData[p];
               Inc(p);
               ty:=CharData[p];
               Inc(p);
               td:=CharData[p];
               Inc(p);
               x:=ix+(tx*xscale);
               y:=iy+(ty*yscale);
      //         memo1.lines.add(IntToStr(tx)+'/'+IntToStr(ty)+'/'+IntToStr(td));
               if(last_o <> td) then
                 begin
                    last_o := td;
                    Write(oFile,'D0'+IntToStr(td)+'*');
                 end;
               Write(oFile,'X'+IntToStr(x)+'Y'+IntToStr(y)+'*');
            end;
         Result.x:=w*xscale;
      end;
   if(rotated = 1) then
      begin
         ty:=CharData[p];
         Inc(p);
         tx:=CharData[p];
         Inc(p);
         Inc(p);
         x:=ix+(tx*yscale);
         y:=iy+(ty*xscale);
         Write(oFile,'X'+IntToStr(x)+'Y'+IntToStr(y)+'*');
         while(p<e) do
            begin
               ty:=CharData[p];
               Inc(p);
               tx:=CharData[p];
               Inc(p);
               td:=CharData[p];
               Inc(p);
               x:=ix+(tx*yscale);
               y:=iy+(ty*xscale);
      //         memo1.lines.add(IntToStr(tx)+'/'+IntToStr(ty)+'/'+IntToStr(td));
               if(last_o <> td) then
                 begin
                    last_o := td;
                    Write(oFile,'D0'+IntToStr(td)+'*');
                 end;
               Write(oFile,'X'+IntToStr(x)+'Y'+IntToStr(y)+'*');
            end;
         Result.y:=w*xscale;
      end;

   if(last_o <> 2) then
     begin
        Write(oFile,'D02*');
     end;
end;
{-----------------------------------------------------------------------------}

procedure TForm6.delete_fill_entry(Sender :TObject; Index :Integer);
var
x       :Integer;
begin
   for x:=Index to (high(fills_array)-1) do fills_array[x]:=fills_array[x+1];
   SetLength(fills_array,high(fills_array));
end;
{-----------------------------------------------------------------------------}

procedure TForm6.add_fill_entry(Sender :TObject; const lx1,ly1,lx2,ly2, ArcSec, Radius :Integer;ArcCenter :Tpoint);
begin
   SetLength(fills_array,high(fills_array)+2);
   fills_array[high(fills_array)][0].position.x:=lx1;
   fills_array[high(fills_array)][0].position.y:=ly1;
   fills_array[high(fills_array)][1].position.x:=lx2;
   fills_array[high(fills_array)][1].position.y:=ly2;
   fills_array[high(fills_array)][0].ArcSection:=ArcSec;
   fills_array[high(fills_array)][1].ArcSection:=ArcSec;
   fills_array[high(fills_array)][0].ArcCenter:=ArcCenter;
   fills_array[high(fills_array)][1].ArcCenter:=ArcCenter;
   fills_array[high(fills_array)][0].Radius:=Radius;
   fills_array[high(fills_array)][1].Radius:=Radius;

end;
{-----------------------------------------------------------------------------}

function TForm6.find_point(Sender :TObject; spoint :TFillsType; var other_point :TFillsType) :Integer;
var
x       :Integer;
begin
if(spoint.ArcSection > 0) then
begin
//showmessage('x');
end;
   for x:=0 to high(fills_array) do
      begin
         if((fills_array[x][0].position.x = spoint.position.x) AND (fills_array[x][0].position.y = spoint.position.y))then
//         if((fills_array[x][0].position.x = spoint.position.x) AND (fills_array[x][0].position.y = spoint.position.y))then
            begin
               Result := x;
               other_point := fills_array[x][1];
//               other_point.x := fills_array[x][1].x;
//               other_point.y := fills_array[x][1].y;
//               other_point.ArcSection := fills_array[x][1].ArcSection;
//               other_point.Radius := fills_array[x][1].Radius;
//               other_point.ArcCenter := fills_array[x][1].ArcCenter;
               exit;
            end;
         if((fills_array[x][1].position.x = spoint.position.x) AND (fills_array[x][1].position.y = spoint.position.y))then
//         if((fills_array[x][1].position.x = spoint.position.x) AND (fills_array[x][1].position.y = spoint.position.y))then
            begin
               Result := x;
               other_point := fills_array[x][0];
//               other_point.x := fills_array[x][0].x;
//               other_point.y := fills_array[x][0].y;
//               other_point.ArcSection := fills_array[x][0].ArcSection;
//               other_point.Radius := fills_array[x][0].Radius;
               exit;
            end;

      end;
   result:=-1;
   exit;
end;
{-----------------------------------------------------------------------------}
procedure TForm6.WriteArc(Sender :TObject; var oFile :TextFile);
begin
if(last_d_code <> d_code) then
    begin
       last_d_code := d_code;
       Write(ofile,'D'+IntToStr(d_code)+'*');
    end;
  writeln(ofile,'');
  write(ofile,'G74*');
  if(radius = 0) then radius := 1; // prevent 0 radius arcs
  if((segments AND 1)=1) then
     begin
        write(ofile,'G01X'+IntToStr(x1)+'Y'+IntToStr(y1+radius)+'D02*');
        write(ofile,'G02X'+IntToStr(x1+radius)+'Y'+IntToStr(y1));
        write(ofile,'I0J'+IntToStr(radius)+'D01*');
        writeln(ofile,'D02*G01*');
     end;
   if((segments AND 2)=2) then
     begin
        write(ofile,'G01X'+IntToStr(x1-radius)+'Y'+IntToStr(y1)+'D02*');
        write(ofile,'G02X'+IntToStr(x1)+'Y'+IntToStr(y1+radius));
        write(ofile,'I'+IntToStr(radius)+'J0D01*');
        writeln(ofile,'D02*G01*');
     end;
  if((segments AND 4)=4) then
     begin
        write(ofile,'G01X'+IntToStr(x1)+'Y'+IntToStr(y1-radius)+'D02*');
        write(ofile,'G02X'+IntToStr(x1-radius)+'Y'+IntToStr(y1));
        write(ofile,'I0J'+IntToStr(radius)+'D01*');
        writeln(ofile,'D02*G01*');
     end;
  if((segments AND 8)=8) then
     begin
        write(ofile,'G01X'+IntToStr(x1+radius)+'Y'+IntToStr(y1)+'D02*');
        write(ofile,'G02X'+IntToStr(x1)+'Y'+IntToStr(y1-radius));
        write(ofile,'I'+IntToStr(radius)+'J0D01*');
        writeln(ofile,'D02*G01*');
     end;
end;
{-----------------------------------------------------------------------------}
function TForm6.LinesCross(Sender :TObject; l1e1,l1e2,l2e1,l2e2 :TPoint; var crosspoint :TPoint):Boolean;
var
lf1,lf2,lf3,lf4,
slope1,slope2,
offset1,offset2 :Extended;
x,y             :Integer;
begin
   result := False;
//****************************************************
// Check for 2 vertical lines
//****************************************************
   if((l1e1.x=l1e2.x) AND (l2e1.x=l2e2.x)) then
      begin
         if(l1e1.x<>l2e1.x) then exit; // both verticle lines, not same line
         exit;                          // ignore same line for now
      end;
//****************************************************
// check for 2 horizontal lines
//****************************************************
   if((l1e1.y=l1e2.y) AND (l2e1.y=l2e2.y)) then
      begin
         if(l1e1.y<>l2e1.y) then exit; // both horizontal lines, not same line
         exit;                      // ignore same line for now
      end;
//****************************************************
 // check for line 1 horizonal and line 2 vertical
//****************************************************
   if((l1e1.y=l1e2.y) AND (l2e1.x=l2e2.x)) then
      begin
         CrossPoint.y := l1e1.y;
         CrossPoint.x := l2e1.x;
         if(CheckLimits(l1e1,l1e2,l2e1,l2e2,CrossPoint) = False) then exit;
         Result := True;
         exit;                                     // These lines cross
      end;

//****************************************************
// check for line 1 vertical and line 2 horizonal
//****************************************************
   if((l1e1.x=l1e2.x) AND (l2e1.y=l2e2.y)) then
      begin
         CrossPoint.y := l2e1.y;
         CrossPoint.x := l1e1.x;
         if(CheckLimits(l1e1,l1e2,l2e1,l2e2,CrossPoint) = False) then exit;
         Result := True;
         exit;                                     // These lines cross
      end;
//****************************************************
// check for line 1 vertical and line 2 sloped
//****************************************************
   if(l1e1.x=l1e2.x) then
      begin
         PointsToSlopeOffset(l2e1, l2e2, Slope2, Offset2);
         lf1:=(Slope2*l1e1.x)+offset2;                       // y=mx+b where X is the vertical line position
         CrossPoint.x:=l1e1.x;
         CrossPoint.y:=Round(lf1);
         if(CheckLimits(l1e1,l1e2,l2e1,l2e2,CrossPoint) = False) then exit;
         Result := True;
         exit;                                               // These lines cross
      end;
//****************************************************
// check for line 1 horizontal and line 2 sloped
//****************************************************
   if(l1e1.y=l1e2.y) then
      begin
         PointsToSlopeOffset(l2e1, l2e2, Slope2, Offset2);
         lf1 := (l1e1.y - Offset2) / Slope2;                 // x = (y-b)/m where y is the horizonal line position
         CrossPoint.y:=l1e1.y;
         CrossPoint.x:=Round(lf1);
         if(CheckLimits(l1e1,l1e2,l2e1,l2e2,CrossPoint) = False) then exit;
         Result := True;
         exit;                                               // These lines cross
      end;
//****************************************************
// check for line 2 vertical and line 1 sloped
//****************************************************
   if(l2e1.x=l2e2.x) then
      begin
         PointsToSlopeOffset(l1e1, l1e2, Slope1, Offset1);
         lf1:=(Slope1*l2e1.x)+offset1;                       // y=mx+b where X is the vertical line position
         CrossPoint.x:=l2e1.x;
         CrossPoint.y:=Round(lf1);
         if(CheckLimits(l1e1,l1e2,l2e1,l2e2,CrossPoint) = False) then exit;
         Result := True;
         exit;                                               // These lines cross
      end;
//****************************************************
// check for line 2 horizontal and line 1 sloped
//****************************************************
   if(l2e1.y=l2e2.y) then
      begin
         PointsToSlopeOffset(l1e1, l1e2, Slope1, Offset1);
         lf1 := (l2e1.y - Offset1) / Slope1;                 // x = (y-b)/m where y is the horizonal line position
         CrossPoint.y:=l2e1.y;
         CrossPoint.x:=Round(lf1);
         if(CheckLimits(l1e1,l1e2,l2e1,l2e2,CrossPoint) = False) then exit;
         Result := True;
         exit;                                               // These lines cross
      end;
//****************************************************
// both lines are sloped
//****************************************************
   PointsToSlopeOffset(l1e1, l1e2, Slope1, Offset1);
   PointsToSlopeOffset(l2e1, l2e2, Slope2, Offset2);

   if(abs(slope1 - slope2) < 1E-100) then exit;              // parallel lines - will not intersect, exit

   lf1 := (offset2 - offset1) / (Slope1 - Slope2);           // calculate intersection
   CrossPoint.x:=Round(lf1);
   CrossPoint.y:=Round((Slope1*lf1)+Offset1);                // Crosspoint is intersection, see if it exists

   if(CheckLimits(l1e1,l1e2,l2e1,l2e2,CrossPoint) = False) then exit;

   result := True;

end;

{-----------------------------------------------------------------------------}
procedure PointsToSlopeOffset(l1e1,l1e2:TPoint; var Slope, Offset :Extended);
var
lf1,lf2,lf3,lf4,
slope1,slope2,
offset1,offset2 :Extended;
begin
// y = mx+b
// slope = rise / run
// slope = y1-y2 / x1-x2
// to get offset subtract MX from both sides
// offset =  y1-(slope*x1)
   lf1:=l1e1.x;
   lf2:=l1e2.x;
   lf3:=l1e1.y;
   lf4:=l1e2.y;
   if(l1e1.x = l1e2.x) then slope:=1E100 else slope := (lf3-lf4) / (lf1-lf2);
   offset := lf3 - (slope * lf1);
end;
{-----------------------------------------------------------------------------}

function TForm6.PointInPolygon(Sender :TObject; APoint, BPoint :TPoint;
                               var closest_index :Integer;
                               var closest_dist :Extended;
                               var ix,iy :Integer):Boolean;
var
CrossCounter,
segptr      :Integer;
cp,
le1,le2,
pe1,pe2     :TPoint;
ixf,iyf,
lf          :Extended;
begin

// PE1/PE2 is a line from the point to 50000,10000 (50 inches x 10 inches)
   closest_index := -1;
   closest_dist := 1E100;
   CrossCounter:= 0;
   pe1:=APoint;
   pe2:=BPoint;
//   pe2.x := 50000;
//   pe2.Y := 10000;
   for segptr := low(fills_sort_array) to (high(fills_sort_array)-1) do
      begin
         le1:=fills_sort_array[segptr].position;
         le2:=fills_sort_array[segptr+1].position;
         if(LinesCross(Self,pe1,pe2,le1,le2,cp)) then
            begin
//memo1.lines.add('X1 = '+IntToStr(le1.x)+' Y1 = '+ IntToStr(le1.y)+
//                ' X2 = '+IntToStr(le2.x)+' Y2 = '+ IntToStr(le2.y)+
//                ' CPX = '+IntToStr(cp.x)+' CPY = '+ IntToStr(cp.y));
               Inc(CrossCounter);
               lf := P2PDistance(pe1,cp);
               if(lf<closest_dist)then
                  begin
                     ix := cp.x;
                     iy := cp.y;
                     closest_dist := lf;
                     closest_index := segptr;
                  end;
            end;
      end;
//   memo1.lines.add(IntToStr(CrossCounter));

   result:=False;
   if((CrossCounter AND $01) = $01) then result:=True;
   if(result) then
      begin
//         memo1.lines.add(IntToStr(closest_index)+'   '+floatToStr(Closest_dist));
//         memo1.lines.add('X1 = '+IntToStr(fills_sort_array[closest_index].x)+' Y1 = '+ IntToStr(fills_sort_array[closest_index].y)+
//                        ' X2 = '+IntToStr(fills_sort_array[closest_index+1].x)+' Y2 = '+ IntToStr(fills_sort_array[closest_index+1].y));
//         memo1.lines.add('PX = '+IntToStr(pe1.x)+' Y1 = '+ IntToStr(pe1.y));

      end;
 end;

{-----------------------------------------------------------------------------}


Procedure TForm6.PadsInPolygon(Sender :TObject);
var
NewRec :TFillsType;
dist,
ix,iy,z,
closest_index,
x,yy,yyy,
padptr  :Integer;
TempTPoint,
le1,
le2,
ppt,
cpt,
bpt,
ept,
lpt     :TPoint;
closest_dist :Extended;
ArcSeq  :Array[0..3] of Integer;
ArcPoints :array[0..20] of TFillsType;
begin
   ept.x := 50000;
   ept.y := 10000;
   cpt.x := fills_sort_array_mid_x;
   cpt.y := fills_sort_array_mid_y;
   SetLength(Cut_In_array,0);
   for padptr := low(Pads_Array) to high(Pads_Array) do
      begin
         lpt:=Pads_Array[padptr].position;
//memo1.lines.add('  *x='+IntToStr(lpt.x)+'y='+IntToStr(lpt.y));
//*******************************************
// check if the pad is not within the max   *
// geographic boundries of the polygon.     *
// Skip if not - speeds up processing       *
//*******************************************
         if(lpt.x < fills_sort_array_min_x) then continue;
         if(lpt.x > fills_sort_array_max_x) then continue;
         if(lpt.y < fills_sort_array_min_y) then continue;
         if(lpt.y > fills_sort_array_max_y) then continue;

//*******************************************
// yes, the pad is not within the max       *
// geographic boundries of the polygon.      *
// Use the PIP (point in polygon)           *
// algorythm.                               *
//*******************************************
//memo1.lines.add(' **x='+IntToStr(lpt.x)+'y='+IntToStr(lpt.y));
         if(PointInPolygon(Self,lpt,ept,closest_index,closest_dist,ix,iy)) then
            begin
//****************************************
// Pad is within the polygon             *
// Add this pad to Cut_In_Array          *
// which is a list of pads in the polygon*
//****************************************

//memo1.lines.add('***x='+IntToStr(lpt.x)+'y='+IntToStr(lpt.y));
               SetLength(Cut_In_Array,high(Cut_In_Array)+2);
               Cut_In_Array[high(Cut_In_Array)] := Pads_Array[padptr];
            end;
      end;

//****************************************
// Cut_In_Array is now full of all of    *
// the pads inside the outline           *
//****************************************

//  Memo1.lines.add('////');

// NEW do the cut_in_array from closest to farthest
//DeleteCutIn(index);

  while(length(Cut_In_Array) > 0) do
     begin
        z:=1000000;
        yyy:=-1;
        for padptr := low(Cut_In_Array) to high(Cut_In_Array) do
           begin
//********************************
// ppt is point at center of pad *
//********************************
              ppt:=Cut_In_Array[padptr].position;

//***************************************
// Find the point closest to ppt (pad)  *
// on the line ppt-->ept where ppt-->ept*
// intersects the polygon.              *
//***************************************
              dist:=ClosestPointToPolygon(ppt,cpt,closest_index);
              if(dist < z) then
                 begin
                    z:=dist;
                    yyy := padptr;
                 end;
           end;
//********************************
// yyy now has the index of the  *
// closest point to the polygon  *
// Add it to the sorted fill     *
// array and delete it from the  *
// cut in array                  *
//********************************



//********************************
// ppt is point at center of pad *
//********************************
        padptr := yyy;
        ppt:=Cut_In_Array[padptr].position;
// Use the correct function based on the shape of the pad to find the closest point to the pad
        if(Cut_In_Array[padptr].shape = 1) then TempTPoint:=FindClosestRound(Cut_In_Array[padptr],Closest_Index);
        if(Cut_In_Array[padptr].shape = 3) then TempTPoint:=FindClosestRound(Cut_In_Array[padptr],Closest_Index);
        if(Cut_In_Array[padptr].shape = 2) then TempTPoint:=FindClosestSquare(Cut_In_Array[padptr],Closest_Index);
        if(Cut_In_Array[padptr].shape = 4) then TempTPoint:=FindClosestSquare(Cut_In_Array[padptr],Closest_Index);
//********************************
// ppt is point at center of pad *
//********************************
        padptr := yyy;

        ppt:=Cut_In_Array[padptr].position;
        ppt:=TempTPoint;
        dist:=ClosestPointToPolygon(ppt,cpt,closest_index);

        ix := cpt.x;
        iy:=cpt.y;

        NewRec.ArcSection := 0;
        NewRec.Radius := 0;
        NewRec.ArcCenter.x  := 0;
        NewRec.ArcCenter.y  := 0;
//***************************************
// Insert space for that point into the *
// polygon and insert that point        *
// If it is not a point in the polygon  *
// (A Endpoint)                         *
//***************************************
// <-----------------------------------------------------------
// if the closest point is a point in the polygon, dont add it
// <-----------------------------------------------------------
        if((Fills_Sort_Array[closest_index].position.x <> ix) OR (Fills_Sort_Array[closest_index].position.y <> iy)) then
           begin
              NewRec.position.x :=ix;
              NewRec.position.y :=iy;
//***************************************
// Insert that point into the polygon   *
//***************************************
              InsertFSAEntry(closest_index, NewRec);
//memo1.lines.add('x = '+IntToStr(NewRec.position.x)+' y = '+IntToStr(NewRec.position.y));
              Inc(closest_index);
           end;
//*********************************************
// Insert the entire cut in into the polygon  *
//*********************************************

// handle square pads
//           Cut_In_Array[padptr].shape

// do cut in for round pad or a via
        if(Cut_In_Array[padptr].shape = 1) then BuildArcSequence(ArcPoints,Cut_In_Array[padptr],ix,iy);
// do cut in for a rectangle pad
        if(Cut_In_Array[padptr].shape = 2) then BuildRectangleSequence(ArcPoints,Cut_In_Array[padptr],ix,iy);
// for now handle ocatagonal pads like round pads
        if(Cut_In_Array[padptr].shape = 3) then BuildArcSequence(ArcPoints,Cut_In_Array[padptr],ix,iy);
// For now handle rounded rectangle the same as a rectangle
        if(Cut_In_Array[padptr].shape = 4) then BuildRectangleSequence(ArcPoints,Cut_In_Array[padptr],ix,iy);
        x:=0;
        while((ArcPoints[x].position.x >= 0) AND (ArcPoints[x].position.y >= 0)) do
           begin
              InsertFSAEntry(closest_index, ArcPoints[x]);
              Inc(closest_index);
              Inc(x);
           end;

          NewRec.ArcSection := 0;
          NewRec.Radius := 0;
          NewRec.ArcCenter.x  := 0;
          NewRec.ArcCenter.y  := 0;
          NewRec.position.x :=ix;
          NewRec.position.y :=iy;

          if((Fills_Sort_Array[closest_index+1].position.x <> ix) OR (Fills_Sort_Array[closest_index+1].position.y <> iy)) then
             begin
                InsertFSAEntry(closest_index, NewRec);
//memo1.lines.add('x = '+IntToStr(NewRec.position.x)+' y = '+IntToStr(NewRec.position.y));
                Inc(closest_index);
             end;
{
  for yyy:=low(Fills_Sort_Array) to high(Fills_Sort_Array) do
  begin
     memo1.lines.add(IntToStr(yyy)+'   x1 = '+IntToStr(Fills_Sort_Array[yyy].position.x)+
                     ' y1 = '+IntToStr(Fills_Sort_Array[yyy].position.y)+
                     ' as1 = '+IntToStr(Fills_Sort_Array[yyy].ArcSection)+
                     ' ar1 = '+IntToStr(Fills_Sort_Array[yyy].Radius));
  end;
}
//memo1.lines.add('end');
        DeleteCutIn(yyy);
     end;


// FIX FOR LAYERS
// Now identify the closest point to a line on the polygon
// point to line distance is:
// point x,y
// line Ax+By+C=0
// (|Ax0+By0+C|) / Sqrt(A^2+B^2)


{
  for x:=low(Cut_In_Array) to high(Cut_In_Array) do
     Memo1.lines.add('x='+IntToStr(Cut_In_Array[x].position.x)+' y='+IntToStr(Cut_In_Array[x].position.y)+
     '  cix='+IntToStr(Cut_In_Array[x].cut_in_pos.x)+' ciy='+IntToStr(Cut_In_Array[x].cut_in_pos.y));
  Memo1.lines.add('====');
  for x:=low(Fills_Sort_Array) to high(Fills_Sort_Array) do
     Memo1.lines.add('x='+IntToStr(Fills_Sort_Array[x].position.x)+' y='+IntToStr(Fills_Sort_Array[x].position.y));
}
end;

{-----------------------------------------------------------------------------}


function SqLineMagnitude(const x1, y1, x2, y2: extended): extended;
begin
 result := (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
end;

{-----------------------------------------------------------------------------}
function P2PDistance(const p1,p2 :TPoint): extended;
begin
 result := Sqrt(SqLineMagnitude(p1.x, p1.y, p2.x, p2.y));
end;

{-----------------------------------------------------------------------------}
// Crosspoint is the intersection of line 1 and line 2
// Return true if Crosspoint with within the limits of the lines

function CheckLimits(const l1e1,l1e2,l2e1,l2e2,CrossPoint :TPoint): Boolean;
begin
Result:=False;
   if(MAX(l1e1.x,l1e2.x)<CrossPoint.x) then exit;            //intersection is right of the line 1, exit
   if(MAX(l2e1.x,l2e2.x)<CrossPoint.x) then exit;            //intersection is right of the line 2, exit

   if(MIN(l1e1.x,l1e2.x)>CrossPoint.x) then exit;            //intersection is left of the line 1, exit
   if(MIN(l2e1.x,l2e2.x)>CrossPoint.x) then exit;            //intersection is left of the line 2, exit

   if(MAX(l1e1.y,l1e2.y)<CrossPoint.y) then exit;            //intersection is above line 1, exit
   if(MAX(l2e1.y,l2e2.y)<CrossPoint.y) then exit;            //intersection is above line 2, exit

   if(MIN(l1e1.y,l1e2.y)>CrossPoint.y) then exit;            //intersection is below line 1, exit
   if(MIN(l2e1.y,l2e2.y)>CrossPoint.y) then exit;            //intersection is below line 2, exit
Result:=True;
end;
{-----------------------------------------------------------------------------}

function DistantPoint(const p1, p2 :TPoint): TPoint;
var
angle,
offset,
x1,x2,x3,
y1,y2,y3,
rise,
run,
slope  :Extended;
begin
   x1:=p1.x;
   x2:=p2.x;
   y1:=p1.y;
   y2:=p2.y;
   rise := y1-y2;
   run := x1-x2;
   if(run<1E-100)then slope := 1E100
   else slope := rise / run;
// y = slope(x) + b = y - slope(x) = b
// so y1-slope(x1) = offset
   offset:=y1-(slope*x1);
   angle := ArcTan(slope);
   y3:=(100000.0*Sin(angle))+y1;
   x3:=(100000.0*Cos(Angle))+x1;
   Result.x:=Round(x3);
   Result.y:=Round(y3);
end;

{-----------------------------------------------------------------------------}
function IsCutIn(Const APoint :TFillsType; var Index :Integer):Boolean;
var
x       :Integer;
begin
Result:=False;
   for x:= low(Cut_In_Array) to high(Cut_In_Array) do
      begin
         if(Cut_In_Array[x].cut_in_pos.x <> APoint.position.x) then Continue;
         if(Cut_In_Array[x].cut_in_pos.y <> APoint.position.y) then Continue;
         Index := x;
         Result:=True;
      end;
end;
{-----------------------------------------------------------------------------}

procedure TForm6.Button2Click(Sender: TObject);
var
lf,ix,iy      :Extended;
p1, p2, p3 :TPoint;
begin
p1.x := 1000;  // pad
p1.y := 1000;
p2.x := 0;  // center
p2.y := 2000;
p3:=DistantPoint(p1,p2);
memo1.lines.add('x='+IntToStr(p3.x)+' y='+IntToStr(p3.y));


p1.x := 700;
p1.y := 300;
p2.x := 800;
p2.y := 111300;
         lf:=(p1.y - p2.y) / (p1.x - p2.x);
         lf := ArcTan(lf);
         lf := lf * 180.0 / pi;
         if(p1.x > p2.x) then lf:=180-lf;
memo1.lines.add(FloatToStr(lf));
end;

{-----------------------------------------------------------------------------}
function PointToLine(const l1e1,l1e2,p1 :TPoint; var crosspoint :TPoint; isarc :Integer):Integer;
var
lf1,
slope1,slope2,
offset1,offset2 :Extended;
begin
   result := 0;

//***************************
// if the line is an arc    *
//***************************
	If(isarc > 0) then
	   begin
          lf1:=P2PDistance(l1e1,p1);
          if(P2PDistance(l1e2,p1)< lf1) then CrossPoint := l1e2
          else CrossPoint := l1e1;
	      Result:=Round(P2PDistance(CrossPoint,p1));
	      exit;
	   end;

//***************************
// if the line is vertical  *
//***************************
   if(l1e1.x = l1e2.x) then
      begin
         if((MIN(l1e1.y,l1e2.y)<p1.y) AND (MAX(l1e1.y,l1e2.y)>p1.y))then
            begin
               Crosspoint.x:=l1e1.x;
               Crosspoint.y:=p1.y;
            end
         else if(MIN(l1e1.y,l1e2.y)>p1.y) then
            begin
               Crosspoint.x:=l1e1.x;
               Crosspoint.y:=MIN(l1e1.y,l1e2.y);
            end
         else
            begin
               Crosspoint.x:=l1e1.x;
               Crosspoint.y:=MAX(l1e1.y,l1e2.y);
            end;
      end
//***************************
// if the line is horiz     *
//***************************
   else if(l1e1.y = l1e2.y) then
      begin
         if((MIN(l1e1.x,l1e2.x)<p1.x) AND (MAX(l1e1.x,l1e2.x)>p1.x))then
            begin
               Crosspoint.x:=p1.x;
               Crosspoint.y:=l1e1.y;
            end
         else if(MIN(l1e1.x,l1e2.x)>p1.x) then
            begin
               Crosspoint.y:=l1e1.y;
               Crosspoint.y:=MIN(l1e1.x,l1e2.x);
            end
         else
            begin
               Crosspoint.x:=l1e1.x;
               Crosspoint.y:=MAX(l1e1.y,l1e2.y);
            end;
      end
//***************************
// if the line is sloped    *
//***************************
   else
      begin
         PointsToSlopeOffset(l1e1, l1e2, Slope1, Offset1);
         Slope2 := 0 - (1.0 / Slope1);
// p1.y = (Slope2 * p1.x) + Offset 2
// -Offset2 = (Slope2 * p1.x) - p1.y
         Offset2 := 0 - ((Slope2 * p1.x) - p1.y);
         lf1 := (offset2 - offset1) / (Slope1 - Slope2);           // calculate intersection
         CrossPoint.x:=Round(lf1);
         CrossPoint.y:=Round((Slope1*lf1)+Offset1);                // Crosspoint is intersection, see if it exists
// if the perpindicular line exisits, use it
         if(CheckLimits(l1e1,l1e2,l1e1,l1e2,CrossPoint) = False) then
            begin
// otherwise find the distance to the nearest end
               lf1:=P2PDistance(l1e1,p1);
               if(P2PDistance(l1e2,p1)< lf1) then CrossPoint := l1e2
               else CrossPoint := l1e1;
            end;
      end;
   Result:=Round(P2PDistance(CrossPoint,p1));
end;

{-----------------------------------------------------------------------------}
function ArcDirection(const ArcStart, ArcEnd, ArcCenter :TPoint; var StartAngle, EndAngle :Integer):Integer;
begin
   if(ArcStart.x < ArcCenter.x) then StartAngle := 270
   else if(ArcStart.x > ArcCenter.x) then StartAngle := 90
   else if(ArcStart.y > ArcCenter.y) then StartAngle := 0
   else if(ArcStart.y < ArcCenter.y) then StartAngle := 180
   else StartAngle := 0;

   if(ArcEnd.x < ArcCenter.x) then EndAngle := 270
   else if(ArcEnd.x > ArcCenter.x) then EndAngle := 90
   else if(ArcEnd.y > ArcCenter.y) then EndAngle := 0
   else if(ArcEnd.y < ArcCenter.y) then EndAngle := 180
   else EndAngle := 0;

   if((StartAngle = 0) AND (EndAngle = 90)) then Result := 1
   else if((StartAngle = 90) AND (EndAngle = 180)) then Result := 1
   else if((StartAngle = 180) AND (EndAngle = 270)) then Result := 1
   else if((StartAngle = 270) AND (EndAngle = 0)) then Result := 1

   else if((StartAngle = 90) AND (EndAngle = 0)) then Result := 0
   else if((StartAngle = 180) AND (EndAngle = 90)) then Result := 0
   else if((StartAngle = 270) AND (EndAngle = 180)) then Result := 0
   else if((StartAngle = 0) AND (EndAngle = 270)) then Result := 0

   else result := 2;

end;

{-----------------------------------------------------------------------------}
function ClosestPointToPolygon(const APoint :TPoint; var CrossPoint :TPoint; var Index :Integer):Integer;
var
isarc,
x,y,z   :Integer;
cp2,
cp,
l1e1,
l1e2    :Tpoint;
begin
   z:=1000000;
   for x:=low(Fills_Sort_array) to (high(Fills_Sort_array)-1) do
      begin
         l1e1 := Fills_Sort_array[x].position;
         l1e2 := Fills_Sort_array[x+1].position;
         isarc := Fills_Sort_array[x].ArcSection;
         y := PointToLine(l1e1,l1e2,APoint,cp,isarc);
         if(y<z) then
            begin
               if((cp.x = l1e2.x) AND (cp.y = l1e2.y)) then continue;
               cp2:=cp;
               z:=y;
               Index := x;
            end;
      end;
   CrossPoint := cp2;
   Result := z;
end;
{-----------------------------------------------------------------------------}
procedure ChooseArcSeq(ThisPoint :pad_rec; var StartPoint :TPoint; var ArcSeq :Array of Integer);
var
lf      :Extended;
mode    :Integer;
begin
   mode := -1;
   if(ThisPoint.cut_in_pos.x <> ThisPoint.position.x)AND(ThisPoint.cut_in_pos.y <> ThisPoint.position.y) then
      begin
         lf:=(ThisPoint.cut_in_pos.Y - ThisPoint.position.y) / (ThisPoint.cut_in_pos.x - ThisPoint.position.X);
         lf := ArcTan(lf);
         lf := lf * 180.0 / pi;
// lf = -90 to +90
         lf:=lf+90;
// lf = 0 t0 180
         if(ThisPoint.position.X > ThisPoint.cut_in_pos.X) then lf:=180+lf;

         if((lf >= 45) AND (lf < 135)) then mode := 3
         else if((lf >= 135) AND (lf < 225)) then mode := 0
         else if((lf >= 225) AND (lf < 315)) then mode := 1
         else mode := 2;
//         Form6.memo1.lines.add(IntToStr(mode)+'  '+FloatToStr(lf)+' x='+IntToStr(ThisPoint.position.X)+' y='+IntToStr(ThisPoint.position.y)+' x2='+IntToStr(ThisPoint.cut_in_pos.X)+' y2='+IntToStr(ThisPoint.cut_in_pos.y));
      end;
if(((ThisPoint.cut_in_pos.x = ThisPoint.position.x)AND(ThisPoint.cut_in_pos.y < ThisPoint.position.y))OR (mode = 2)) then
      begin
         StartPoint.x := ThisPoint.position.X;
         StartPoint.y := ThisPoint.position.Y - radius;
         ArcSeq[0]:=4;
         ArcSeq[1]:=2;
         ArcSeq[2]:=1;
         ArcSeq[3]:=8;
      end
   else if(((ThisPoint.cut_in_pos.x = ThisPoint.position.x)AND(ThisPoint.cut_in_pos.y > ThisPoint.position.y))OR (mode = 0)) then
      begin
         StartPoint.x := ThisPoint.position.X;
         StartPoint.y := ThisPoint.position.Y + radius;
         ArcSeq[0]:=1;
         ArcSeq[1]:=8;
         ArcSeq[2]:=4;
         ArcSeq[3]:=2;
      end
   else if(((ThisPoint.cut_in_pos.y = ThisPoint.position.y)AND(ThisPoint.cut_in_pos.x < ThisPoint.position.x))OR (mode = 1)) then
      begin
         StartPoint.x := ThisPoint.position.X-radius;
         StartPoint.y := ThisPoint.position.Y;
         ArcSeq[0]:=2;
         ArcSeq[1]:=1;
         ArcSeq[2]:=8;
         ArcSeq[3]:=4;
      end
   else if(((ThisPoint.cut_in_pos.y = ThisPoint.position.y)AND(ThisPoint.cut_in_pos.x > ThisPoint.position.x))OR (mode = 3)) then
      begin
         StartPoint.x := ThisPoint.position.X + radius;
         StartPoint.y := ThisPoint.position.Y;
         ArcSeq[0]:=8;
         ArcSeq[1]:=4;
         ArcSeq[2]:=2;
         ArcSeq[3]:=1;
      end;


end;
{-----------------------------------------------------------------------------}
procedure InsertFSAEntry(const InsertAddress:Integer; const NewRec :TFillsType);
var
yy      :Integer;
begin
   SetLength(Fills_Sort_Array,High(Fills_Sort_Array)+2);   // create empty space
   for yy:=High(Fills_Sort_Array)-1 downto InsertAddress+1 do
      Fills_Sort_Array[yy+1]:=Fills_Sort_Array[yy];
   Fills_Sort_Array[yy+1]:=NewRec;
end;

{-----------------------------------------------------------------------------}
procedure GetArcEndpoint(const ArcCenter, ArcStart :TPoint; const Radius, Segment :Integer; var EndPoint :TPoint);
begin
   case(Segment) of
   (1):     begin
               EndPoint.x := ArcCenter.x + Radius;
               EndPoint.y := ArcCenter.y;
            end;
   (2):     begin
               EndPoint.x := ArcCenter.x;
               EndPoint.y := ArcCenter.y + Radius;
            end;
   (4):     begin
               EndPoint.x := ArcCenter.x - Radius;
               EndPoint.y := ArcCenter.y;
            end;
   (8):     begin
               EndPoint.x := ArcCenter.x;
               EndPoint.y := ArcCenter.y - Radius;
            end;
   end;

end;

{-----------------------------------------------------------------------------}
procedure DeleteCutIn(const Index :Integer);
var
x       :Integer;
begin
   for x:=index to (high(Cut_In_Array)-1) do Cut_In_Array[x] := Cut_In_Array[x+1];
   SetLength(Cut_In_Array, high(Cut_In_Array));
end;

{-----------------------------------------------------------------------------}
procedure BuildArcSequence(var ArcPoints :Array of TFillsType; APad_Rec :pad_rec; var ix,iy :Integer);
var
lpt     :TPoint;
ArcSeq  :Array[0..3] of Integer;
NewRec  :TFillsType;
aptr    :Integer;
begin
   NewRec.ArcSection := 0;
   NewRec.Radius := 0;
   NewRec.ArcCenter.x  := ix;
   NewRec.ArcCenter.y  := iy;

   aptr := 0;
   Radius := (APad_Rec.width div 2)+8;
   APad_Rec.cut_in_pos.x := ix;
   APad_Rec.cut_in_pos.y := iy;
   ChooseArcSeq(APad_Rec,lpt,ArcSeq);
   NewRec.position := lpt;
   ArcPoints[aptr]:=NewRec;
   Inc(aptr);

   NewRec.Radius := (APad_Rec.width div 2)+8;
   NewRec.ArcCenter  := APad_Rec.position;
   GetArcEndpoint(NewRec.ArcCenter,NewRec.position,NewRec.Radius,ArcSeq[0],lpt);
   NewRec.position := lpt;
   NewRec.ArcSection := ArcSeq[0];
   ArcPoints[aptr]:=NewRec;
   Inc(aptr);

   GetArcEndpoint(NewRec.ArcCenter,NewRec.position,NewRec.Radius,ArcSeq[1],lpt);
   NewRec.position := lpt;
   NewRec.ArcSection := ArcSeq[1];
   ArcPoints[aptr]:=NewRec;
   Inc(aptr);

   GetArcEndpoint(NewRec.ArcCenter,NewRec.position,NewRec.Radius,ArcSeq[2],lpt);
   NewRec.position := lpt;
   NewRec.ArcSection := ArcSeq[2];
   ArcPoints[aptr]:=NewRec;
   Inc(aptr);

   GetArcEndpoint(NewRec.ArcCenter,NewRec.position,NewRec.Radius,ArcSeq[3],lpt);
   NewRec.position := lpt;
   NewRec.ArcSection := ArcSeq[3];
   ArcPoints[aptr]:=NewRec;
   Inc(aptr);

   NewRec.ArcSection := 0;
   NewRec.position.x := -1;
   NewRec.position.y := -1;
   ArcPoints[aptr]:=NewRec;
end;
{-----------------------------------------------------------------------------}
procedure BuildRectangleSequence(var RectPoints :Array of TFillsType; APad_Rec :pad_rec; var ix,iy :Integer);
var
lpt     :TPoint;
RectSeq  :Array[0..16] of TPoint;
NewRec  :TFillsType;
x,
aptr    :Integer;
begin

   NewRec.ArcSection := 0;
   NewRec.Radius := 0;
   NewRec.ArcCenter.x  := ix;
   NewRec.ArcCenter.y  := iy;
   aptr := 0;
   cwidth := APad_Rec.width div 2+8;
   cheight := APad_Rec.height div 2+8;

   APad_Rec.cut_in_pos.x := ix;
   APad_Rec.cut_in_pos.y := iy;

   ChooseRectangleSeq(APad_Rec,lpt,RectSeq);
   NewRec.position := lpt;
   RectPoints[aptr]:=NewRec;
   Inc(aptr);

   x:=0;
   while((RectSeq[x].x <> 0)OR(RectSeq[x].y <> 0)) do
      begin
         NewRec.position.x := APad_Rec.position.x + RectSeq[x].x;
         NewRec.position.y := APad_Rec.position.y + RectSeq[x].y;
         RectPoints[aptr]:=NewRec;
         Inc(aptr);
         Inc(x);
      end;
   NewRec.position.x := -1;
   NewRec.position.y := -1;
   RectPoints[aptr]:=NewRec;

end;

{-----------------------------------------------------------------------------}
procedure ChooseRectangleSeq(ThisPoint :pad_rec; var StartPoint :TPoint; var RectSeq :Array of TPoint);
var
lf      :Extended;
x,
mode    :Integer;
lpt     :TPoint;
begin
   lpt.x:=0;
   lpt.y:=0;
   for x:=0 to 10 do RectSeq[x]:=lpt;
   mode := -1;
   if(ThisPoint.cut_in_pos.x = ThisPoint.position.x)then
      begin
         if(ThisPoint.cut_in_pos.y > ThisPoint.position.y)then lf:=180
         else lf:=0;
      end
   else
      begin
         lf:=(ThisPoint.cut_in_pos.Y - ThisPoint.position.y) / (ThisPoint.cut_in_pos.x - ThisPoint.position.X);
         lf := ArcTan(lf);
         lf := lf * 180.0 / pi;
// lf = -90 to +90
         lf:=lf+90;
// lf = 0 t0 180
         if(ThisPoint.position.X > ThisPoint.cut_in_pos.X) then lf:=180+lf;
      end;
         if(abs(lf - 45.0) <= 22.5) then mode :=0
         else if(abs(lf - 90.0) <= 22.5) then mode :=1
         else if(abs(lf - 135.0) <= 22.5) then mode :=2
         else if(abs(lf - 180.0) <= 22.5) then mode :=3
         else if(abs(lf - 225.0) <= 22.5) then mode :=4
         else if(abs(lf - 270.0) <= 22.5) then mode :=5
         else if(abs(lf - 315.0) <= 22.5) then mode :=6
         else mode :=7;

//         Form6.memo1.lines.add('Rect '+IntToStr(mode)+'  '+FloatToStr(lf)+' x='+IntToStr(ThisPoint.position.X)+' y='+IntToStr(ThisPoint.position.y)+' x2='+IntToStr(ThisPoint.cut_in_pos.X)+' y2='+IntToStr(ThisPoint.cut_in_pos.y));

      case(mode) of
      (0):   begin
                StartPoint.x := ThisPoint.position.X + cwidth;
                StartPoint.y := ThisPoint.position.Y - cheight;
                RectSeq[0].x := cwidth; RectSeq[0].y := cheight;
                RectSeq[1].x := -cwidth; RectSeq[1].y := cheight;
                RectSeq[2].x := -cwidth; RectSeq[2].y := -cheight;
                RectSeq[3].x := +cwidth; RectSeq[3].y := -cheight;
             end;

      (1):   begin
                StartPoint.x := ThisPoint.position.X + cwidth;
                StartPoint.y := ThisPoint.position.Y;
                RectSeq[0].x := cwidth; RectSeq[0].y := cheight;
                RectSeq[1].x := -cwidth; RectSeq[1].y := cheight;
                RectSeq[2].x := -cwidth; RectSeq[2].y := -cheight;
                RectSeq[3].x := +cwidth; RectSeq[3].y := -cheight;
                RectSeq[4].x := +cwidth; RectSeq[4].y := 0;
            end;

      (2):   begin
                StartPoint.x := ThisPoint.position.X + cwidth;
                StartPoint.y := ThisPoint.position.Y + cheight;
                RectSeq[0].x := -cwidth; RectSeq[0].y := cheight;
                RectSeq[1].x := -cwidth; RectSeq[1].y := -cheight;
                RectSeq[2].x := +cwidth; RectSeq[2].y := -cheight;
                RectSeq[3].x := cwidth; RectSeq[3].y := cheight;
             end;

      (3):   begin
                StartPoint.x := ThisPoint.position.X;
                StartPoint.y := ThisPoint.position.Y + cheight;
                RectSeq[0].x := -cwidth; RectSeq[0].y := cheight;
                RectSeq[1].x := -cwidth; RectSeq[1].y := -cheight;
                RectSeq[2].x := +cwidth; RectSeq[2].y := -cheight;
                RectSeq[3].x := cwidth; RectSeq[3].y := cheight;
                RectSeq[4].x := 0; RectSeq[4].y := cheight;
             end;

      (4):   begin
                StartPoint.x := ThisPoint.position.X - cwidth;
                StartPoint.y := ThisPoint.position.Y + cheight;
                RectSeq[0].x := -cwidth; RectSeq[0].y := -cheight;
                RectSeq[1].x := cwidth; RectSeq[1].y := -cheight;
                RectSeq[2].x := cwidth; RectSeq[2].y := cheight;
                RectSeq[3].x := -cwidth; RectSeq[3].y := cheight;
             end;

      (5):   begin
                StartPoint.x := ThisPoint.position.X - cwidth;
                StartPoint.y := ThisPoint.position.Y;
                RectSeq[0].x := -cwidth; RectSeq[0].y := -cheight;
                RectSeq[1].x := cwidth; RectSeq[1].y := -cheight;
                RectSeq[2].x := cwidth; RectSeq[2].y := cheight;
                RectSeq[3].x := -cwidth; RectSeq[3].y := cheight;
                RectSeq[4].x := -cwidth; RectSeq[4].y := 0;
             end;

      (6):   begin
                StartPoint.x := ThisPoint.position.X - cwidth;
                StartPoint.y := ThisPoint.position.Y - cheight;
                RectSeq[0].x := cwidth; RectSeq[0].y := -cheight;
                RectSeq[1].x := cwidth; RectSeq[1].y := cheight;
                RectSeq[2].x := -cwidth; RectSeq[2].y := cheight;
                RectSeq[3].x := -cwidth; RectSeq[3].y := -cheight;
             end;

      (7):   begin
                StartPoint.x := ThisPoint.position.X;
                StartPoint.y := ThisPoint.position.Y - cheight;
                RectSeq[0].x := cwidth; RectSeq[0].y := -cheight;
                RectSeq[1].x := cwidth; RectSeq[1].y := cheight;
                RectSeq[2].x := -cwidth; RectSeq[2].y := cheight;
                RectSeq[3].x := -cwidth; RectSeq[3].y := -cheight;
                RectSeq[4].x := 0; RectSeq[4].y := -cheight;
             end;
        end;
end;

//-----------------------------------------------------------

function  FindClosestRound(ppt :pad_rec;ClosestIndex :Integer):TPoint;
var
ci,
BestDist,
dist,
Radius  :Integer;
cpt,
pnt1,
pnt2    :TPoint;
begin
   BestDist:=1000000;
   Radius := (ppt.width div 2)+8;
   pnt1.x := ppt.position.x + Radius;
   pnt1.y := ppt.position.y;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

   pnt1.x := ppt.position.x - Radius;
   pnt1.y := ppt.position.y;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

   pnt1.x := ppt.position.x;
   pnt1.y := ppt.position.y+Radius;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

   pnt1.x := ppt.position.x;
   pnt1.y := ppt.position.y-Radius;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;
   result:=pnt2;
end;

//-----------------------------------------------------------

function  FindClosestSquare(ppt :pad_rec;ClosestIndex :Integer):TPoint;
var
ci,
BestDist,
dist,
Radius  :Integer;
cpt,
pnt1,
pnt2    :TPoint;
begin
   BestDist:=1000000;
   Radius := (ppt.width div 2)+8;
//1
   pnt1.x := ppt.position.x + Radius;
   pnt1.y := ppt.position.y;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

//2
   pnt1.x := ppt.position.x - Radius;
   pnt1.y := ppt.position.y;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

//3
   pnt1.x := ppt.position.x;
   pnt1.y := ppt.position.y+Radius;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

//4
   pnt1.x := ppt.position.x;
   pnt1.y := ppt.position.y-Radius;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

//5
   pnt1.x := ppt.position.x + Radius;
   pnt1.y := ppt.position.y + Radius;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

//6
   pnt1.x := ppt.position.x - Radius;
   pnt1.y := ppt.position.y - Radius;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

//7
   pnt1.x := ppt.position.x - Radius;
   pnt1.y := ppt.position.y + Radius;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

//8
   pnt1.x := ppt.position.x + Radius;
   pnt1.y := ppt.position.y - Radius;
   dist:=ClosestPointToPolygon(pnt1,cpt,ci);
   if(dist<BestDist) then
      begin
         pnt2:=pnt1;
         BestDist:=dist;
      end;

   result:=pnt2;
end;
//-----------------------------------------------------------

procedure WriteGerberElement(const x, y, dCmd, dCode :Integer);
var
locs    :String;
begin
  if((LastGerberX = x) AND
     (LastGerberY = y) AND
     (LastGerberDCmd = dCmd) AND
     (LastGerberDCode = dCode)) then exit;

  if(LastGerberDCode <> dCode) then
     begin
        locs:=IntToStr(dCode);
        if(length(locs)<2) then locs:='0'+locs;
        writeln(ofile,'D'+locs+'*');
        if(lastGerberDCmd < 3) then
           begin
              locs:=IntToStr(dCmd);
              write(ofile,'D0'+locs+'*');
           end;
        lastGerberDCode:=dCode;
     end;

  if((dCmd = 3) AND ((LastGerberDCmd < 2) OR (LastGerberDCmd > 3))) then
     begin
        locs:='02';
        if(length(locs)<2) then locs:='0'+locs;
        write(ofile,'D'+locs+'*');
     end;


  if((dCmd <= 2) AND (LastGerberDCmd <> dCmd){ AND ((LastGerberX <> x) OR (LastGerberY <> y))}) then
     begin
        locs:=IntToStr(dCmd);
        if(length(locs)<2) then locs:='0'+locs;
        write(ofile,'D'+locs+'*');
        lastGerberDCmd:=dCmd;
     end;

  if((LastGerberX <> x) OR (LastGerberY <> y)) then
     begin
        if(dcMd = 3)then write(ofile,'D02*');
        write(ofile,'X'+IntToStr(x)+'Y'+IntToStr(y)+'*');
        LastGerberX := x;
        LastGerberY := y;
        if((LastGerberDCmd <> dCmd) OR (dCmd = 3))then
           begin
              locs:=IntToStr(dCmd);
              if(length(locs)<2) then locs:='0'+locs;
              write(ofile,'D'+locs+'*');
              lastGerberDCmd:=dCmd;
           end;
        writeln(oFile);
     end;
end;

end.
